#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif /* HAVE_CONFIG_H */

#include "manconfig.h"

/* Flex emits several functions which might reasonably have various
 * attributes applied and many unused macros; none of these are our problem.
 */
#if GNUC_PREREQ(8,0)
#  pragma GCC diagnostic ignored "-Wsuggest-attribute=malloc"
#endif
#pragma GCC diagnostic ignored "-Wsuggest-attribute=pure"
#pragma GCC diagnostic ignored "-Wunused-macros"

#line 17 "lexgrog.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 6
#define YY_FLEX_SUBMINOR_VERSION 4
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#ifndef SIZE_MAX
#define SIZE_MAX               (~(size_t)0)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

/* begin standard C++ headers. */

/* TODO: this is always defined, so inline it */
#define yyconst const

#if defined(__GNUC__) && __GNUC__ >= 3
#define yynoreturn __attribute__((__noreturn__))
#else
#define yynoreturn
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an
 *   integer in range [0..255] for use as an array index.
 */
#define YY_SC_TO_UI(c) ((YY_CHAR) (c))

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *
/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START
/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)
/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin  )
#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2
    
    #define YY_LESS_LINENO(n)
    #define YY_LINENO_REWIND_TO(ptr)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )
#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	int yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = NULL; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)
/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = NULL;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart ( FILE *input_file  );
void yy_switch_to_buffer ( YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer ( FILE *file, int size  );
void yy_delete_buffer ( YY_BUFFER_STATE b  );
void yy_flush_buffer ( YY_BUFFER_STATE b  );
void yypush_buffer_state ( YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state ( void );

static void yyensure_buffer_stack ( void );
static void yy_load_buffer_state ( void );
static void yy_init_buffer ( YY_BUFFER_STATE b, FILE *file  );
#define YY_FLUSH_BUFFER yy_flush_buffer( YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer ( char *base, yy_size_t size  );
YY_BUFFER_STATE yy_scan_string ( const char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes ( const char *bytes, int len  );

void *yyalloc ( yy_size_t  );
void *yyrealloc ( void *, yy_size_t  );
void yyfree ( void *  );

#define yy_new_buffer yy_create_buffer
#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}
#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer( yyin, YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}
#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap() (/*CONSTCOND*/1)
#define YY_SKIP_YYWRAP
typedef flex_uint8_t YY_CHAR;

FILE *yyin = NULL, *yyout = NULL;

typedef int yy_state_type;

extern int yylineno;
int yylineno = 1;

extern char *yytext;
#ifdef yytext_ptr
#undef yytext_ptr
#endif
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state ( void );
static yy_state_type yy_try_NUL_trans ( yy_state_type current_state  );
static int yy_get_next_buffer ( void );
static void yynoreturn yy_fatal_error ( const char* msg  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;
#define YY_NUM_RULES 141
#define YY_END_OF_BUFFER 142
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static const flex_int16_t yy_accept[1494] =
    {   0,
        0,    0,    0,    0,   67,   67,   67,   67,    0,    0,
        0,    0,    0,    0,    0,    0,  119,  119,    0,    0,
        0,    0,    0,    0,  126,  126,    8,    8,    0,    0,
        0,    0,    0,    0,    0,    0,  142,  141,   29,   29,
       29,  140,   67,   67,  140,  140,  140,  138,  140,  136,
       83,   67,   67,  140,   83,  106,  106,  106,  101,  106,
      108,  108,  107,  113,  113,  113,  112,  118,  118,  118,
      118,  118,  119,  121,  121,  120,  123,  123,  122,  125,
      125,  124,  126,  126,  140,  137,  140,  140,  140,    7,
       10,    7,    7,    6,    6,    6,    4,   18,   18,   18,

       19,   19,    0,   28,    0,   27,   27,   29,   67,    0,
      138,    0,    0,  139,   67,   67,  139,  135,  139,  139,
      135,   83,   67,    0,    0,  138,    0,  136,   70,   67,
       76,    0,   62,    0,    0,   64,   66,    0,    0,   61,
       63,   61,    0,    0,    0,    0,    0,    0,   67,    0,
       67,   67,  139,  135,   83,   67,    0,   64,    0,  106,
        0,    0,  101,   94,   95,   96,   97,   98,   99,  100,
      108,  107,  113,    0,    0,    0,  112,  112,  118,    0,
        0,    0,  119,  121,  120,  123,  122,  125,  124,  126,
      137,    0,    0,  126,  126,  139,  139,  139,  139,  126,

      137,   54,    0,  126,   39,    7,    0,    9,    0,   10,
        7,    6,    0,    3,    4,    3,    4,    3,   18,    0,
        0,    0,   18,   19,   28,    0,    0,    0,   27,   27,
       27,   27,   27,   27,   27,   27,   27,   27,   57,    0,
        0,   67,    0,    0,   36,   36,   36,   36,   36,   36,
       36,   36,    0,   50,    0,    0,    0,    0,    0,    0,
      130,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,   48,    0,   57,    0,   49,    0,   58,   76,
       72,    0,    0,    0,    0,    0,    0,    0,    0,   75,
       75,   75,    0,    0,    0,    0,    0,    0,   69,    0,

       77,   78,    0,   79,    0,    0,   81,    0,    0,   67,
        0,    0,   36,   36,   36,   36,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
       93,  102,  103,  104,  105,  101,   94,   95,   96,   97,
       98,   99,  100,    0,    0,    0,    0,    0,    0,   60,
        0,  126,   38,   38,  126,   38,   38,   38,   38,   37,
       54,    7,    0,    0,    0,    9,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    7,    5,    3,    3,    4,    4,    4,    3,
        0,    0,    0,    0,    0,   16,    0,   21,   27,   27,

       27,   27,   20,   27,   27,   27,   57,    0,    0,    0,
        0,    0,    0,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   51,   41,    0,    0,    0,    0,    0,  128,
       59,    0,  130,   47,  129,    0,    0,   30,    0,    0,
        0,  127,   34,   53,    0,   35,   33,   52,   32,    0,
        0,    0,   49,   84,   73,   62,   55,   63,   68,    0,

        0,    0,    0,    0,    0,    0,    0,    0,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       85,    0,   87,   92,   88,   89,   90,   91,    0,    0,
        0,   64,    0,   93,  102,  103,  104,  105,    0,    0,
        0,  116,  114,    0,   38,   38,   38,   38,   37,   38,
       38,    7,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    7,    5,    3,
        3,    4,    4,    4,    0,    3,    3,   12,   14,   13,
       15,   11,   17,   21,   25,   26,   20,   22,   24,   23,

       55,    0,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   30,   36,   36,   36,   36,   34,   36,   36,   35,
       33,   36,   32,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   40,  132,  131,   45,  128,   59,   46,   47,  129,
      134,  133,   30,   42,   44,   31,  127,   34,   34,   53,
       43,   35,   33,   52,   32,    0,   84,   55,   74,    0,
       71,   56,   80,   82,   36,   36,   36,   36,   36,   36,

       36,   36,   36,   36,   36,   36,   36,   36,   85,   86,
       87,   92,   88,   89,   90,   91,    0,   65,    0,  110,
        0,  116,  117,  114,  115,   38,   38,    7,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    7,    3,    3,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    3,    3,   25,

       26,   22,   24,   23,   56,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   30,   36,   36,   31,   36,   34,
       34,   36,   36,   35,   33,   36,   32,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,  132,
      131,   45,  134,  133,   44,   43,   56,   56,   82,   36,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   86,
       65,  109,  110,  111,  117,  115,    7,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,

        7,    3,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    3,
       36,   36,   36,   36,   36,   36,   36,   36,   36,   36,
       36,   36,   36,   36,   36,   36,   36,   36,  109,  111,
        7,    0,    2,    0,    0,    0,    0,    0,    0,    0,

        0,    0,    0,    0,    0,    0,    0,    0,    0,    7,
        3,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    1,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    1,    4,    1,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    0,    1,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    1,    0,

        1,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        3,   36,   36,   36,    7,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    7,    3,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    1,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    1,    4,    1,    4,    4,    4,

        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    1,    1,    4,
        4,    4,    4,    4,    4,    1,    4,    4,    4,    4,
        4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
        4,    4,    0,    1,    1,    0,    0,    0,    0,    0,
        0,    1,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    3,    7,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    7,    3,    3,    4,
        4,    1,    0,    1,    0,    0,    0,    0,    0,    0,

        0,    0,    1,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    3,    3,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    8,    0,    0,    1,
        0,    1,    0,    0,    0,    0,    0,    1,    1,    0,
        0,    0,    0,    1,    1,    1,    0,    1,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    0,    0,

        0,    0,    0,    1,    0,    1,    0,    0,    0,    0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    0,    0,    0,    0,    0,    1,    1,    0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    0,
        0,    0,    0,    1,    1,    1,    1,    1,    1,    0,
        0,    0,    0,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    0,    0,    0,    0,    1,
        1,    1,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0

    } ;

static const YY_CHAR yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    4,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    5,    6,    7,    8,    9,    6,   10,   11,   12,
       13,   14,   15,   16,   17,   18,    1,   19,   20,   21,
       22,   23,   24,   25,   26,   27,   27,    1,    1,    1,
        1,    1,    1,    1,   28,   29,   30,   31,   32,   33,
       34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
       44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
       54,   55,   56,    6,   57,   58,   59,   60,   61,   62,

       63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
       73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
       83,   84,    6,   85,    6,   86,    1,    1,   87,    1,
        1,   88,   89,   90,    1,    1,   91,   92,    1,    1,
       93,    1,    1,   94,   95,   96,    1,    1,   97,    1,
       98,   99,    1,    1,    1,  100,  101,  102,    1,    1,
      103,    1,    1,  104,    1,  105,  106,  107,  108,  109,
        1,    1,  110,  111,  112,  113,  114,    1,    1,  115,
        1,    1,    1,    1,  116,    1,  117,    1,  118,  119,
        1,    1,    1,    1,  120,  121,    1,    1,    1,    1,

        1,    1,    1,  122,    1,    1,    1,  123,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,  124,    1,    1,    1,  125,  126,    1,
      127,    1,    1,    1,  128,  129,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static const YY_CHAR yy_meta[130] =
    {   0,
        1,    2,    3,    4,    2,    1,    5,    1,    1,    1,
        6,    7,    1,    1,    1,    1,    1,    1,    8,    9,
        9,    9,    9,    8,    8,    8,    8,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
       10,   10,   10,    1,    1,    1,    1,    1,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1
    } ;

static const flex_int16_t yy_base[1677] =
    {   0,
        0,    0,    0,    2,    6,    0,  134,  138,  141,  142,
      222,    0,  351,    0,  140,  477, 5447, 5446,  555,    0,
      684,    0,  813,    0,  145,  154,  149,  162,  164,  165,
        0,    0,  169,  174, 5444, 5443, 5446, 7367, 7367,  194,
     5442, 7367,  480,  487,  941, 5389, 5387,  179, 5423,    0,
      994,  952,  959, 5436,  476, 7367, 5371, 5352,  190,  486,
     7367, 5369,    0, 7367, 5368,  144,  212, 7367, 5367, 5302,
     5305, 5308,    0, 7367, 5363,    0, 7367, 5362,    0, 7367,
     5361,    0,  964,  970, 5359,  498,  204, 5355, 5302,    0,
      515, 5354, 5342, 7367, 5343, 5290,  982,    0,  510, 5341,

     7367, 5340,  529,  533, 5339,    0, 1048, 1018, 1083, 1099,
      521, 5324, 1027, 7367, 1104, 1115, 1126, 5285, 5284, 5321,
     1180,  938, 1144, 5330, 5250,  536,  538,    0, 7367,  954,
        0, 1151, 7367, 1121,  475,  543, 7367,  974,  483, 5255,
     7367, 7367, 5320,    0, 5292, 5296, 1239,  982, 1134,  948,
     1162, 1200, 5299, 1239, 1028, 1271, 1225, 7367, 1071, 7367,
     5221, 1173, 1228,  945,  986, 1013, 1045, 1060, 1109, 1139,
     7367,    0, 7367, 5226, 5232, 5231, 1155, 1186, 7367, 5215,
     5220, 5225,    0, 7367,    0, 7367,    0, 7367,    0, 1290,
     1234, 1295, 5285, 1300, 1306, 5284,  978, 5281, 5228, 1311,

     1316, 1320, 5281, 1325, 7367,    0, 1329, 1335, 5280, 1339,
     5277, 7367, 5274, 5273, 5272, 5271, 1321, 5270,    0, 1204,
     5273, 1315, 1210, 7367, 7367, 5272, 1275, 5271,    0, 1348,
     1372, 5202,  165, 1354, 5200, 1183, 5193, 1313, 1349, 1342,
     1344, 1422, 1430, 1438, 5267, 1448, 1464,  962,  980,  157,
     1518, 1593, 1383, 7367, 5266, 1409, 5225, 1444, 5224,  424,
     1417, 1442, 1461, 5194, 1349,    0, 5189, 5201,  472, 1027,
     5199, 1448, 7367, 5250, 1416, 1409,    0, 5248, 1474,    0,
     7367,    0, 5192,  148, 5190, 5164, 5179, 5166, 5174, 7367,
        0,    0, 1497,    0,    0,  923, 5160, 5175, 7367,    0,

     7367, 7367,    0, 7367,    0, 1594, 7367, 1504,    0, 1537,
     1119, 5238, 1532, 5236, 1678, 1753, 5159, 1659, 5161, 5126,
      878, 5125, 5124, 1480, 1080, 5122, 5133, 1097, 5116, 5131,
     1524, 1528, 1543, 1547, 1553, 1566, 1570, 1572, 1574, 1579,
     1581, 1586, 1604, 5123, 5118, 5115, 5131, 5118, 5117, 1620,
     1624, 1629,    0, 1633, 1689, 5186, 1716, 5183, 5130, 7367,
     1637,    0, 1838, 5183, 1847, 1860, 5182,  462, 5144,  481,
      919, 1870, 5155, 5062, 5135, 5067, 5060,   87, 5067, 1241,
     5068, 5075, 5170,    0, 5167, 5166, 5165, 5164, 1695, 5163,
     5125, 5148, 5121, 5146, 5119, 7367, 5109,    0, 1628, 1680,

     1684, 1685, 1703, 1710, 1726, 1732, 1747, 1320, 5070, 5084,
     1357, 5067, 5082, 5145, 1773, 1781, 1066, 1792, 1854, 1203,
     1160, 1786, 1798, 5144, 1890, 1198, 1948, 1427, 1784, 1914,
     1910, 1969, 1107, 1817, 2050,  975, 1095, 1665, 1857, 1221,
     1928, 5143, 2005,    0, 2003, 5142, 5140, 1978, 5129, 1851,
     5137, 2011, 1976, 1112, 5109, 5108, 2092, 2118, 2191, 1396,
     2047, 2029, 7367, 1923, 1749, 1764, 1800, 1816, 1843, 1856,
     1867, 1936, 1942, 1950, 1990, 1995, 2015, 2031, 2043, 2053,
     2054, 2103, 2274,    0, 2104, 2105, 2114,    0, 2170, 1420,
     5027, 5042,    0, 2171, 7367, 7367, 2202, 7367, 7367,    0,

        0, 5093, 5047, 5046,    0,    0, 5094, 5089, 5096, 2277,
     1142, 2282, 1021, 1150, 1883, 1435, 1507, 2227, 5095, 2242,
     2203, 5013, 2204, 2208, 2209, 2210, 2244, 2276, 1426, 5011,
     5026, 7367, 5036, 2286, 2295, 2297, 2299, 2305, 5025, 5031,
     5026, 2307, 2309, 5025,    0, 2314, 2318, 5082,    0, 2324,
        0,    0, 2341, 5083, 2363, 1509, 5053, 1684, 1604, 2334,
     1673, 1753, 1828, 1947, 2358, 2245, 5035, 4991, 1395, 1378,
     4959, 4958, 4971, 4986, 4960, 4988, 4961, 5070,    0, 5067,
     5066, 5065, 5064, 2491, 2619, 5063, 5062, 7367, 7367, 7367,
     7367, 7367, 7367,    0,    0,    0, 2328,    0,    0,    0,

     2332, 5003, 2286, 2353,    0, 1515, 2337, 2418, 2370, 2392,
     2410, 2429, 2434, 2438, 2442, 2446, 2450, 2454, 2469, 2473,
     2477, 2497, 2501, 2505, 2509, 2513, 2519,    0, 2538, 2542,
     2546,    0, 2550,    0, 5052,    0, 4995, 1440, 4993, 4968,
     4983, 4970, 4977, 5039,    0, 2554, 1266, 2355, 1441, 1483,
     5038, 2746, 5035, 5034, 2772, 5031, 1553, 2547, 5030, 2573,
     1633, 7367,    0,    0,    0, 2345, 2349, 2456, 2521, 2528,
        0,    0, 2558, 2559,    0, 2575, 2577, 2583, 2585,    0,
        0, 2587, 2589,    0, 2591, 4974, 2593, 2595, 7367, 4973,
     7367, 2597, 7367,    0, 2601, 1567, 2605, 2625, 2629, 2633,

     2637, 2641, 1702, 4945, 4960, 2465, 1698, 1591, 2645, 2647,
     2649, 2656, 2662, 2663, 2667, 2668, 4970, 7367, 4966, 2673,
     4954, 2674, 2675, 2679, 2680, 2685, 2689,    0, 2184, 2693,
     2176, 5010, 1238, 2318, 2331, 2672, 2394, 2621, 2396, 2703,
     2414, 2855, 2456, 2630, 4993, 4979, 4978, 4904, 4925, 4909,
     4913, 4918, 4887, 2748, 4884, 4879, 4879, 5001,    0,    0,
        0,    0, 2927, 2869, 2667, 4965, 2661, 2671, 2840, 4975,
     4882, 1827, 4955, 4887, 4880,  114, 4887, 1815, 4887, 4893,
     2904, 2683, 4953, 2680, 2689, 2841, 4962, 4868, 1847, 4938,
     4866, 4858, 1383, 4854, 1981, 4854, 4858,    0,    0,    0,

        0,    0,    0,    0, 2707, 2755, 1727, 1715, 2757, 1920,
     1777,    0, 2714, 4952,    0,    0,    0, 2720, 2724, 2734,
     2752, 2759,    0,    0, 2763, 2767,    0, 2859, 2876, 2888,
     2920,    0,    0, 2947, 2952,    0, 2970, 4950, 4921, 2974,
     4920, 4919,    0, 2314,  987, 3054, 3080, 2058, 2398,    0,
        0,    0,    0,    0,    0,    0, 2754, 2861,    0, 2978,
     2982, 2997, 3001, 3005, 3009, 3013, 3017, 4918, 1945, 2865,
     7367, 2890, 2933, 2937, 2941, 2960,    0, 2829, 3032, 2964,
     4917, 2829, 4908, 4869, 2852, 2841, 3132, 2895, 4886, 4823,
     4801, 4790, 4789, 4797, 1991, 1143, 2283, 4789, 4787, 4796,

     4895,    0,    0, 3203, 3145, 2946, 4857, 2946, 2981, 3155,
     4842, 4749, 1974, 4822, 4753, 4745, 1835, 4749, 2616, 4747,
     4754, 2968, 4819, 3135, 2982, 3140, 2980, 2991, 2998, 2999,
     3223, 2955, 4800, 4755, 3321, 3264, 1891, 2862, 4723, 4720,
     4733, 4740, 4714, 4742, 4714, 2987, 4796, 3139, 3000, 3347,
     2994, 3005, 3007, 3098, 3348, 3122, 4778, 4715, 4794, 3289,
     2462, 2938, 4678, 4675, 4688, 4702, 4675, 4675, 4647,    0,
     3173, 2377, 3214,    0,    0,    0,    0,    0,    0,    0,
     3224, 4758, 4757, 3233, 4756, 3251, 3259, 4746, 3075, 3240,
        0, 3135, 3247, 3138, 3152, 3198, 4712, 3293, 2264, 2968,

     4656, 4635, 3186, 4630, 4586, 4584, 4585, 4570, 4590, 4672,
        0,    0, 3431, 3408, 3267, 4624, 3265, 3285, 3350, 4634,
     4536, 2396, 4609, 4541, 4533, 2510, 4539, 3206, 4529, 4535,
     3293, 4602, 3349, 3338, 3424, 3331, 3343, 3344, 3345, 3462,
     3231, 4584, 4538, 3549, 3588, 2495, 3193, 4506, 4505, 4517,
     4502, 4476, 4504, 4477, 3357, 3388, 3350, 4575, 1552, 3352,
     3359, 3425, 3367, 3404, 3400, 3454, 3422, 3614, 3430, 3412,
     4558, 4544, 3660, 3593, 3659, 3689, 4537, 4459, 4477, 4435,
     4440, 4439, 4408, 3400, 4405, 4400, 4400, 3444, 3511, 3438,
     4515, 2434, 3449, 3452, 3596, 3453, 3464, 3462, 3618, 3481,

     3726, 3487, 3467, 4495, 4481,    0, 3698, 3750, 3761, 4480,
     4405, 4426, 4408, 4413, 4417, 4377, 3536, 4374, 4368, 4368,
        0, 3335, 3560, 3571,    0, 3509, 4454, 3647, 3662, 4364,
     4361, 4358, 4367, 3744, 3757, 3780, 4337, 3789, 4449, 4442,
     4441, 3889, 3831, 3771, 1875, 3599, 3773, 3872, 3295, 1296,
     3540, 1390, 2211, 2378, 3651, 1024, 3473, 1601, 2389, 3747,
     2731, 3807, 3716, 3909, 3757, 3802, 3826, 3836, 3967, 3772,
     3172, 1971, 2721, 3979, 3551, 3549, 2331, 2502, 2528, 3328,
     2878, 2574, 2946, 3818, 3844, 3789, 2914, 2510, 3822, 3848,
     3906, 3870, 3941, 3862, 3851, 3914, 4023, 3908, 3956, 3396,

     1525, 4435, 4017, 4068, 4030, 3499, 2717, 3230, 1264, 3066,
     1287, 3440, 3640, 2646, 2476, 2167, 3954, 3735, 3965, 3780,
     3966, 2494, 3216, 4020, 3921, 4027, 4037, 3226, 4091, 2998,
     3017, 3435, 3234, 2506, 3072, 3165, 3858, 3744, 3816, 3646,
     3061, 3321, 3590, 4099, 3630, 3567, 3860, 4407, 4363, 3882,
     3938, 4114, 3956, 4378, 4397, 4312, 4323, 4288, 4259, 4244,
     4242, 4251, 3714, 3391, 3741, 4242, 4239, 4217, 4311, 7367,
     3990, 4279, 3542, 4211, 4197, 4105, 4120, 4124, 4128, 4132,
     4145, 4158, 4162, 4168, 4172, 4213, 4295,    0,    0, 7367,
     4151, 3974, 4013, 4031, 4284, 4188, 4013, 4017, 4001, 4259,

     4202, 4281, 4113, 3812, 3943, 4192, 4171, 4072, 4180, 4157,
     4154, 4163, 4138, 4158,    0,    0, 4137, 4205, 4081, 4074,
     4073, 4045, 4179, 4197, 4228, 4051, 4137, 4154,    0, 4188,
     4215, 4242, 4076, 4231, 4247,    0, 4262, 4257, 4258, 3940,
     3938, 3932, 3922, 4264, 4299, 4319, 3897, 4323, 4220, 3959,
     3888, 3879, 3867, 4244, 4311, 3869, 3853, 3869, 4315, 4006,
     3803, 3790, 4337, 4338, 4344, 4345, 4351, 4355, 4359, 4375,
     4396, 4400, 4406, 4414, 4415, 3758, 4252, 3799, 4392, 4421,
     3709, 4241, 4412, 3795, 3755, 3620, 3601, 3597, 3559, 4438,
     4514, 4483, 4439, 4568, 4620, 4457, 4674, 4646, 3568, 3553,

     3526, 4269, 4711, 4445,    0, 4451, 3521, 3446, 3439, 3427,
     4737, 4469, 4789, 4470, 4843, 4476, 4798, 4484, 4897, 4569,
     4949, 4576, 3382, 3380, 4314, 4445, 3453, 4577, 4685, 3364,
     4637, 4686, 4903, 4662, 4955, 4959, 4731, 4976, 4980, 3347,
     3339, 3244, 3179, 5041, 5085, 5137, 5181, 5233, 5277, 3137,
     3125, 3108, 2936, 5329, 4797, 5357, 4852, 5356, 4856, 5384,
     4860, 5436, 4984, 5464, 4990, 2904, 2852, 2838, 2799, 4735,
     4814, 4818, 2771, 2650, 2644, 2624, 2548, 2545, 2510, 2431,
     2327, 2328, 2192, 2160, 2178, 2010, 1954, 1896, 1899, 1886,
     1747, 1709, 7367, 5517, 5528, 5539, 5550, 5561, 5572, 5583,

     5594, 5605, 5616, 5627, 5631, 5642, 5653, 5664, 5675, 5686,
     5697, 5708, 5719, 5730, 5741, 5752, 5763, 5767, 5778, 5789,
     5800, 5811, 5816, 5817, 5822, 5833, 5844, 5855, 5866, 5877,
     5888, 5899, 5910, 5921, 5932, 5943, 5954, 5965, 1693, 5976,
     5987, 5998, 6009, 6020, 6031, 6042, 6053, 1627, 6055, 6066,
     6077, 6088, 6099, 6110, 6121, 6132, 6143, 6154, 6165, 6176,
     6187, 6198, 6209, 6220, 6231, 6242, 6253, 6264, 6275, 1130,
     6277, 6288, 6299, 6310, 6321, 6332, 6343, 6354, 6365, 6376,
     6387, 6398, 6409, 6420, 6431, 6442, 6453, 6464, 6475, 6486,
     6497, 6508, 6519, 6530, 6541, 6552, 6563, 6574, 6585, 6596,

     6607, 6618, 6629, 6640, 6651, 6662, 6673, 6684, 6695, 6706,
     6717, 6728, 6739, 6750, 6761, 6772, 6783, 6794, 6805, 6816,
     6827, 6838, 6849, 6860, 6871, 6882, 6893, 6904, 6915, 6926,
     6937, 6948, 6959, 6970, 6981, 6992, 7003, 7014, 7025, 7036,
     7047, 7058, 7069, 7080, 7091, 7096, 7106, 7117, 7128, 7139,
     7150, 7161, 7172, 7183, 7194, 7205, 7216, 7227, 1114, 7238,
     7249, 7260, 7271, 7282, 7293, 7300, 7310, 7315, 7319,  517,
      505, 7329, 7340, 7351, 7356,  170
    } ;

static const flex_int16_t yy_def[1677] =
    {   0,
     1494, 1494, 1495, 1495, 1493,    5,    5,    5, 1496, 1496,
     1493,   11, 1493,   13, 1497, 1497, 1498, 1498, 1493,   19,
     1493,   21, 1493,   23, 1499, 1499, 1500, 1500, 1501, 1501,
     1494, 1494, 1502, 1502, 1503, 1503, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1504, 1493, 1493, 1493, 1493, 1493, 1505,
     1493, 1493, 1504, 1493,   51, 1493, 1493, 1493, 1506, 1493,
     1493, 1493, 1507, 1493, 1493, 1493, 1508, 1493, 1493, 1493,
     1493, 1493, 1509, 1493, 1493, 1510, 1493, 1493, 1511, 1493,
     1493, 1512, 1493, 1504, 1493, 1493, 1493, 1493, 1493, 1513,
     1493, 1513, 1513, 1493, 1493, 1493, 1514, 1515, 1493, 1515,

     1493, 1493, 1493, 1493, 1493, 1516, 1516, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1517, 1493, 1493, 1493, 1493,
     1493,   51, 1504, 1493, 1493, 1493, 1493, 1518, 1493, 1493,
     1519, 1493, 1493, 1520, 1521, 1493, 1493, 1493, 1522, 1493,
     1493, 1493, 1523, 1524, 1525, 1493, 1493, 1493, 1493, 1493,
     1493, 1517, 1493,  121,   51, 1504, 1520, 1493, 1522, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1526, 1493, 1493, 1493, 1493, 1527, 1493, 1493, 1493,
     1493, 1493, 1528, 1493, 1529, 1493, 1530, 1493, 1531, 1493,
     1493, 1493, 1493, 1493, 1532, 1493, 1493, 1493, 1493, 1504,

     1493, 1493, 1493, 1493, 1493, 1533, 1493, 1493, 1493, 1493,
     1533, 1493, 1493, 1534, 1535, 1534, 1535, 1534, 1536, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1537, 1537,
     1537, 1537, 1537, 1537, 1537, 1537, 1537, 1537, 1493, 1493,
     1493, 1493, 1538, 1493, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1539, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1540, 1493, 1493, 1541, 1493, 1493, 1542,
     1493, 1543, 1543, 1543, 1543, 1543, 1543, 1543, 1543, 1493,
     1544, 1545, 1493, 1546, 1547, 1547, 1547, 1547, 1493, 1548,

     1493, 1493, 1549, 1493, 1550, 1493, 1493, 1493, 1551, 1493,
     1538, 1493, 1538, 1538, 1538, 1538, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1543, 1543, 1543, 1547, 1547, 1547,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1552, 1552, 1553, 1552, 1552, 1552, 1552, 1493,
     1493, 1554, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1554, 1555, 1556, 1556, 1557, 1557, 1557, 1558,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1559, 1560, 1560,

     1560, 1560, 1560, 1560, 1560, 1560, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1561, 1538, 1538, 1538, 1562, 1563, 1538,
     1538, 1538, 1538, 1538, 1538, 1538,  435,  435,  435, 1538,
     1538, 1538, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1564, 1493, 1493, 1493, 1565, 1493, 1493,
     1493, 1493, 1566, 1493, 1493, 1493, 1493, 1493, 1493, 1567,

     1568, 1569, 1493, 1493, 1570, 1571, 1572, 1573, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1574, 1538, 1538,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1575, 1575, 1575, 1575, 1575, 1575,
     1575, 1576, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1576, 1577, 1578,
     1578, 1579, 1579, 1579, 1493, 1580, 1580, 1493, 1493, 1493,
     1493, 1493, 1493, 1581, 1582, 1583, 1584, 1585, 1586, 1587,

     1493, 1493, 1538, 1538, 1588, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1589, 1538, 1538,
     1538, 1590, 1538, 1591, 1538, 1592, 1592, 1592, 1592, 1592,
     1592, 1592, 1592, 1538, 1593, 1538, 1594, 1538, 1538, 1538,
     1538, 1538, 1538, 1538,  652, 1538, 1595, 1538, 1538, 1538,
     1596, 1493, 1597, 1598, 1599, 1493, 1493, 1493, 1493, 1493,
     1600, 1601, 1493, 1493, 1602, 1493, 1493, 1493, 1493, 1603,
     1604, 1493, 1493, 1605, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1606, 1538, 1538, 1538, 1538, 1538, 1538,

     1538, 1538, 1607, 1607, 1607, 1538, 1538, 1538, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1608, 1608, 1609, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1609, 1610, 1611,
     1612, 1613, 1612, 1613, 1612, 1612, 1612, 1612, 1612, 1612,
     1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1614, 1615, 1616,

     1617, 1618, 1619, 1620, 1493, 1538, 1538, 1538, 1538, 1538,
     1538, 1621, 1538, 1538, 1622, 1623, 1624, 1538, 1538, 1538,
     1538, 1538, 1625, 1626, 1538, 1538, 1627, 1538, 1538, 1538,
     1538, 1628, 1629, 1538, 1538, 1630, 1538, 1538, 1538, 1538,
     1538, 1538, 1631, 1632, 1538, 1538,  846, 1633, 1634, 1635,
     1636, 1637, 1638, 1639, 1640, 1641, 1493, 1493, 1642, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1538, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1643, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,

     1643, 1644, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645,
     1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645,
     1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645,
     1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645, 1645,
     1645, 1645, 1645, 1645, 1645, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1646, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1647,
     1538, 1538, 1538, 1648, 1649, 1650, 1651, 1652, 1653, 1654,
     1538, 1538, 1538, 1538, 1538, 1655, 1538, 1538, 1493, 1493,
     1656, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,

     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1656,
     1657, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,

     1493, 1493, 1493, 1493, 1493, 1659, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1660, 1538, 1538, 1655, 1661, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1662, 1663, 1664, 1493, 1493, 1661, 1665,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1666, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,

     1493, 1659, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1666, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1229, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1667, 1493,
     1493, 1493, 1493, 1493, 1493, 1663, 1662, 1662, 1662, 1663,
     1663, 1663, 1664, 1664, 1664, 1493, 1493, 1665, 1665, 1493,
     1493, 1493, 1493, 1493, 1668, 1493, 1493, 1493, 1493, 1493,

     1493, 1669, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1667, 1667, 1493, 1493, 1493, 1493,
     1493, 1493, 1662, 1663, 1664, 1493, 1493, 1493, 1670, 1493,
     1493, 1493, 1493, 1493, 1493, 1671, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1672, 1673, 1674, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1668, 1493, 1493, 1493, 1669, 1493,
     1493, 1493, 1673, 1672, 1672, 1672, 1672, 1673, 1673, 1673,
     1673, 1674, 1674, 1674, 1674, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1675, 1493, 1493, 1493, 1493, 1493, 1672,
     1672, 1672, 1673, 1673, 1673, 1674, 1674, 1674, 1493, 1493,

     1493, 1493, 1493, 1493, 1676, 1493, 1493, 1493, 1493, 1493,
     1672, 1672, 1672, 1672, 1673, 1673, 1673, 1673, 1674, 1674,
     1674, 1674, 1493, 1493, 1493, 1675, 1493, 1493, 1493, 1493,
     1391, 1672, 1672, 1394, 1673, 1673, 1397, 1674, 1674, 1493,
     1493, 1493, 1493, 1672, 1391, 1673, 1394, 1674, 1397, 1493,
     1493, 1493, 1493, 1672, 1672, 1411, 1672, 1673, 1673, 1415,
     1673, 1674, 1674, 1419, 1674, 1493, 1493, 1493, 1493, 1445,
     1447, 1449, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493,    0, 1493, 1493, 1493, 1493, 1493, 1493, 1493,

     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,

     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493
    } ;

static const flex_int16_t yy_nxt[7497] =
    {   0,
     1493, 1493,   40,   41,   40,   41,   42,   43,   44,   45,
       43,   42,   42,   42,   42,   42,   46,   47,   42,   42,
       42,   48,   49,   46,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   42,
       51,   42,   42,   42,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       50,   50,   50,   50,   50,   50,   50,   50,   50,   50,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,

       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   42,   42,   52,   53,   54,   52,   52,
       53,   54,   52,   69,   57,   57,   83,   84,   85,   83,
       42,   91,   92,   93,   42,   83,   84,   85,   83, 1493,
       86,   87,   58,   58,   91,   92,   93,   95,   95,   86,
       87,   99,  100,  422,   96,   96,   99,  100,   70, 1426,
      126,   97,   97,  126,   71,  571,   72,  572,   55,   59,
       59,  163,   55,  399,  163,  103,  104,  105,  103,   88,

      399,   89,  174,  175,  106,  176,  202,  203,   88,   70,
       89,  107,  939,  178,  940,   71,  178,   72,  497,  497,
       60,   60,   61,   61,   61,   62,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   61,   61,   61,   61,   61,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,
       63,   63,   63,   63,   63,   63,   63,   63,   63,   63,

       63,   63,   63,   63,   63,   63,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   61,   61,   61,   61,   61,
       61,   64,   64,   64,   65,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   66,   64,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,

       67,   67,   67,   67,   64,   64,   64,   64,   64,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   67,   67,   67,   67,   67,
       67,   67,   67,   67,   67,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       64,   64,   64,   64,   64,   64,   64,   64,   64,   64,
       69,  109,  110,  110,  109,  471,  291,  157,  115,  116,
      117,  115,  158,  556,  472,  111,  112,  118,  119,  201,

      201,  201,  201,  120,  121,  164,  165,  166,  167,  168,
      169,  170,  220,  221, 1359,   70,  207,  208,  209,  207,
      558,   71,  126,   72,  556,  126, 1355,  222,  292,  159,
      103,  225,  226,  103,  113,  227,  228,  126,  484,  279,
      126,  122,  279,  106,  279,  296,   70,  279,  297,  485,
      107,  558,   71,  298,   72,   74,   74,   74,   75,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,

       76,   76,   76,   76,   76,   76,   76,   76,   74,   74,
       74,   74,   74,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   77,   77,   77,   78,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,

       77,   77,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   77,   77,   77,
       77,   77,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,

       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   80,   80,   80,   81,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   80,   80,   80,   80,
       80,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   82,   82,   82,
       82,   82,   82,   82,   82,   82,   82,   80,   80,   80,

       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,  110,  123,  110,  110,  337,  273,  472,  337,
      559,  274,  130,  149,  275,  130,  149,  112,  130,  526,
      151,  152,  153,  151, 1493,  190,  130,  111,  190,  118,
      119,  194,  195,  196,  194,  293,  154, 1493,  293,  191,
      192,  559, 1493,  308,  294,  215,  308,  338,  216, 1493,
      338,  276,  309,  504,  504,  112,  129,  129,  130,  129,

      131,  131,  132,  129,  133,  134,  150,  135,  150,  360,
      136,  137,  130,  155,  339,  197,  420,  339,  193,  103,
      104,  105,  103, 1493,  198,  130,  199,  217,  106,  360,
     1290,  130,  138,  130,  421,  107,  218,  273,  240,  157,
      360,  274,  984,  239,  158,  130,  340,  139,  140,  340,
      626,  141,  129,  138,  129,  129,  142,  143,  217,  138,
      360,  341,  144,  138,  341,  145,  146,  129, 1493,  129,
      147,  130,  129,  138,  148,  138,  230,  129,  129,  130,
      241,  324,  422,  231,  109,  110,  110,  109,  232,  486,
      486,  487,  233,  234,  235,  698,  236, 1493,  111,  112,

      110,  110,  110,  110,  130,  242,  243,  244,  242, 1493,
      342,  237,  130,  342, 1493,  112,  246,  116,  247,  246,
      112,  311,  509, 1255,  238,  248,  249,  110,  116,  110,
      110,  250,  251,  328,  965,  149,  329,  113,  149,  301,
      343,  330,  112,  343, 1493,  115,  116,  117,  115,  111,
      532,  532, 1493,  112,  118,  119,  178,  627,  113,  178,
      120,  121, 1493,  310,  311,  312,  310,  533,  533,  252,
      281,  281,  281,  281,  281,  281,  281,  281,  623,  283,
      112,  253,  254,  284,  253,  285,  286,  178,  150,  651,
      178,  287,  332,  333,  334,  335,  288,  255,  122,  289,

     1493,  313,  152,  314,  313, 1493,  220,  221,  256,  605,
      248,  249,  220,  221,  257,  258,  150,  315,  259,  695,
      260,  222,  261, 1493,  262,  263,  264,  222,  265,  336,
      266,  699,  336,  890,  124,  201,  201,  201,  201,  267,
      610,  268,  405,  269,  606,  405,  270,  332,  333,  334,
      335,  271, 1004,  306,  316,  306,  272,  307,  307,  307,
      307,  307,  307,  307,  307,  307,  317,  318,  502,  319,
     1290,  320,  151,  152,  153,  151,  414,  227,  228,  321,
      322,  118,  119,  283,  632,  106,  323,  325,  154,  285,
      326,  190,  107, 1290,  190,  327,  350,  350,  350,  350,

      288,  352, 1290,  289,  352,  191,  192,  354,  355,  356,
      354,  351,  194,  195,  196,  194,  192,  201,  201,  201,
      201,  361,  361,  361,  361,  155,  204,  388,  731,  204,
      207,  363,  364,  207,  574,  575,  365,  366,  367,  365,
      207,  208,  209,  207,  193,  731,  391,  403,  392,  398,
      407,  357,  398,  407,  193,  389,  197,  393,  403,  394,
      358,  395,  359,  368,  403,  198,  389,  199,  396, 1259,
      369,  370,  389,  398,  371,  372,  398,  373,  403,  193,
     1261,  374,  399,  399,  253,  254,  389,  253,  403,  403,
      601,  601,  399,  399,  397,  403, 1290,  389, 1493,  403,

      400,  375,  657,  389,  408,  403,  411,  409,  480,  412,
      464,  480,  410,  464,  413,  958,  400,  407,  473,  403,
      407,  473,  401,  242,  243,  244,  242,  602,  602, 1493,
      403,  415,  243,  416,  415,  961,  403, 1493,  112,  110,
      243,  110,  110, 1493,  465,  464,  417,  474,  464,  418,
      110,  415,  418,  465,  112,  376,  377,  378,  379,  475,
      380,  747,  381,  382,  417,  415,  116,  415,  415,  614,
      465,  490,  467,  476,  491,  279,  113,  465,  279,  492,
      417,  963,  478,  964,  417, 1493,  468,  477,  467,  465,
      686,  686,  112,  478,  469,  478,  717,  717,  293,  478,

      465,  293,  419,  749,  750,  308,  478,  294,  308, 1493,
      840,  840,  478,  478,  309,  748,  701, 1493,  417,  423,
      254,  489,  423,  845,  478,  534,  478,  813,  534,  535,
      478, 1290,  535,  443, 1493,  424,  443,  478,  310,  311,
      312,  310,  529,  478,  536,  530,  425,  536,  537,  845,
      531,  537,  426,  427,  538,  507,  428,  538,  429,  414,
      430,  729,  431,  432,  433, 1099,  434,  336,  435, 1493,
      336,  337,  420,  338,  337,  339,  338,  436,  339,  437,
      340,  438,  341,  340,  439,  341,  510,  342,  702,  440,
      342,  150,  729, 1493,  441,  129,  442,  443,  442,  444,

      444,  445,  446,  447,  448,  343,  449, 1290,  343,  450,
      451,  443,  307,  307,  307,  307,  307,  307,  307,  307,
      307,  350,  350,  350,  350,  350,  350,  350,  350,  398,
      352,  452,  398,  352,  546,  508,  505,  546,  361,  361,
      361,  361, 1186,  414,  734,  192,  453,  454,  861,  547,
      455,  442,  452,  442,  442,  456,  457,  869,  452, 1186,
      464,  458,  452,  464,  459,  460,  442, 1493,  442,  461,
      443,  442,  452,  462,  452,  734,  442,  442,  443,  423,
      254,  398,  423,  193,  398,  595,  596,  548,  595,  596,
      354,  355,  356,  354,  465,  424,  584,  585,  584,  584,

     1493,  583,  481,  465,  597,  511,  512,  597,  513,  968,
      514,  598,  426,  427,  598,  731,  428, 1493,  515,  516,
      430,  740,  431,  432,  433,  517,  434,  599,  435, 1493,
      599,  628,  420,  600,  357,  522,  600,  436,  732,  437,
      523,  438,  629,  358,  439,  359,  731,  549,  407,  440,
      464,  407,  740,  464,  441,  129,  442,  443,  442,  444,
      444,  445,  446,  447,  518,  663,  449,  549,  663,  519,
      451,  443,  868,  868,  415,  110,  415,  415,  549, 1493,
      869,  971,  415,  243,  415,  415, 1493,  607, 1493,  417,
      607,  452,  741,  418,  110,  415,  418,  417,  549,  423,

      254,  464,  423,  733,  464, 1339,  520,  454,  417,  971,
      455,  442,  452,  442,  442,  456,  457,  664,  452, 1493,
      664,  458,  452,  741,  459,  460,  442,  417,  442,  461,
      443,  442,  452,  462,  452,  417,  442,  442,  443,  365,
      553,  554,  365,  972,  665,  615,  419,  665,  365,  553,
      554,  365,  607, 1493,  616,  607, 1493,  666,  443, 1493,
      666,  555,  366,  367,  555,  603,  368,  742,  667, 1492,
      422,  667,  443,  369,  370,  368,  624,  371,  372,  624,
      373, 1290,  369,  370,  374, 1493,  371,  372,  368,  373,
      935,  608, 1493,  374,  608,  369,  370,  560,  742,  371,

      372,  561,  373,  936,  375,  562,  374,  604,  942,  943,
      959,  563, 1493,  375,  947,  617, 1493,  564,  617,  630,
      630,  631, 1493,  960,  464,  609,  375,  464,  565,  662,
     1493,  443,  561, 1048,  609, 1049,  562,  668,  609,  443,
      668,  620,  563,  473,  618,  609,  473, 1493,  564,  608,
     1493,  669,  608,  616,  669,  621,  619, 1077,  376,  377,
      378,  379,  622,  380,  700,  381,  382,  376,  377,  378,
      379, 1493,  380,  622,  381,  382,  611, 1290, 1493,  622,
      376,  377,  378,  379, 1491,  380,  743,  381,  382,  566,
      612,  670,  611,  622,  670, 1129,  671,  609,  613,  671,

      988,  633,  972,  622,  622, 1493,  443, 1493,  609,  443,
      622, 1078,  646, 1493,  622,  646,  672,  743, 1490,  672,
      622,  647,  635,  635,  635,  635,  635,  635,  635,  635,
      660, 1493,  673,  660,  622,  673,  637, 1044,  648,  661,
      638,  649,  639,  640,  674,  622,  650,  674,  641, 1493,
     1045,  622, 1493,  642,  675,  676,  643,  675,  676,  510,
      507,  658, 1105,  658,  985,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  966,  967, 1489,  625,  625,  625,
      625,  625,  625,  625,  625,  625,  625,  625,  625,  625,
      625,  625,  625,  625,  625,  625,  625,  625,  625,  625,

      625,  625,  625,  652,  677,  681,  682,  677,  681,  682,
     1488,  653,  653,  653,  653,  683, 1002, 1003,  683,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  685,  687, 1290,  685,  687,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,
      654,  654,  654,  654,  654,  654,  654,  654,  654,  654,

      654,  654,  655,  688,  709,  711,  688,  709,  711,  712,
      713,  714,  712,  713,  714,  878,  882, 1290,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656, 1493,  715,  878,  882,  715,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656,  656,  678, 1487,  716,  678, 1493,
      716,  443, 1486,  608, 1493,  637,  608,  534, 1493,  703,
      534,  639,  704,  679, 1268,  443,  535,  705,  536,  535,

      537,  536,  642,  537,  706,  643,  538,  707,  722,  538,
      724,  722,  708,  724, 1485,  546,  502,  609,  546,  726,
      350,  726,  726,  790,  983,  550,  609,  723,  550,  597,
      547,  744,  597,  688,  727,  561,  688, 1290,  607, 1493,
      679,  607,  555,  553,  554,  555,  666,  744,  806,  666,
      667,  807,  561,  667,  443, 1493,  808, 1493,  696,  740,
     1128,  735,  443,  697,  555,  553,  554,  555,  548,  368,
      740,  608, 1493,  736,  608, 1129,  369,  370,  548, 1493,
      371,  372,  737,  373, 1290,  735,  738,  374, 1005, 1006,
      740,  368,  735,  815, 1493, 1290,  815,  736,  369,  370,

      508,  740,  371,  372,  736,  373,  737,  375,  986,  374,
      739,  608, 1493,  737,  608,  809,  735,  739,  810,  608,
     1493, 1484,  608,  811,  814,  845,  845, 1483,  736,  375,
      816, 1493, 1122,  816,  740,  817, 1493,  737,  817,  818,
     1493,  739,  818,  819, 1493,  885,  819,  820, 1493,  740,
      820,  617, 1493, 1114,  617,  821, 1493,  668,  821, 1173,
      668,  376,  377,  378,  379,  740,  380, 1493,  381,  382,
      822, 1493, 1174,  822,  823, 1493,  885,  823,  824, 1493,
      740,  824, 1290,  376,  377,  378,  379,  740,  380,  969,
      381,  382,  763,  585,  763,  763,  962,  764,  825, 1493,

     1290,  825,  826, 1493, 1297,  826,  827, 1493, 1290,  827,
      828, 1493, 1290,  828,  829, 1493, 1290,  829,  740,  765,
      830, 1493,  669,  830, 1090,  669,  766,  767, 1110,  670,
      768,  769,  670,  770, 1290,  869,  869,  771,  831,  833,
     1493, 1090,  833,  834, 1493,  772,  834,  835, 1493, 1493,
      835,  837, 1493, 1482,  837,  646, 1493,  773,  646,  673,
      674, 1206,  673,  674,  647,  659,  659,  659,  659,  659,
      659,  659,  659,  659,  660, 1493,  676,  660,  677,  676,
     1290,  677, 1111,  661,  678,  831,  678,  678,  682,  678,
      683,  682,  685,  683,  687,  685,  688,  687,  858,  688,

     1090,  858,  860, 1493, 1267,  860,  862, 1493, 1177,  862,
     1178,  774,  775,  776,  777, 1207,  778, 1090,  779,  780,
      585,  585,  585,  585, 1115,  781,  863, 1493, 1304,  863,
      864, 1493, 1481,  864,  865, 1493, 1116,  865,  866, 1493,
     1480,  866,  867, 1493, 1339,  867,  709,  782,  870,  709,
      711,  870, 1290,  711,  783,  784,  884,  712,  785,  786,
      712,  787, 1119,  713,  714,  788,  713,  714,  715,  716,
      885,  715,  716,  789,  873,  722,  875,  873,  722,  875,
      724,  876,  888,  724,  876,  790,  726,  350,  726,  726,
      726,  350,  726,  726,  879,  880,  881,  879,  922,  740,

      924,  885,  925,  740,  879,  880,  881,  879,  858, 1051,
     1052,  858,  740,  888,  946,  973, 1493, 1479,  973,  948,
      949,  818, 1493, 1290,  818,  819, 1493, 1290,  819,  922,
      740,  924, 1106,  925,  740,  820, 1493, 1290,  820,  791,
      792,  793,  794,  740,  795,  946,  796,  797, 1493,  895,
      948,  949,  895,  821, 1493,  858,  821, 1493,  858, 1493,
      822, 1493, 1089,  822,  825, 1493, 1478,  825,  826, 1493,
     1266,  826, 1477,  846,  846,  846,  846,  846,  846,  846,
      846,  846,  846,  846,  846,  846,  846,  846,  846,  846,
      846,  846,  846,  846,  846,  846,  846,  846,  846,  847,

      847,  847,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  847,  847,  971,  971,  972,  972, 1110,
      847,  847,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  847,  847,  847,  879,  880,  881,  879,
      828, 1493,  858,  828,  992,  858,  870,  926,  950,  870,
      740,  927,  951,  896,  897,  928,  952,  829, 1493,  740,
      829,  929,  953,  886, 1290,  995,  887,  930,  954,  830,
     1493,  989,  830, 1476,  989,  992,  740,  765,  931,  955,

     1475,  740,  927,  951,  766,  767,  928,  952,  768,  769,
      740,  770,  929,  953,  886,  771,  995,  887,  930,  954,
     1290,  830, 1493,  772,  830, 1248,  996,  740,  904,  585,
      904,  904,  782,  905,  873,  773, 1474,  873,  990,  783,
      784,  990,  875,  785,  786,  875,  787, 1473,  834, 1493,
      788,  834, 1290,  835, 1493,  906,  835,  996,  789,  932,
      956,  876,  907,  908,  876,  993,  909,  910,  993,  911,
      790,  837, 1493,  912,  837,  981, 1493, 1031,  981,  860,
     1493,  913,  860,  987, 1493, 1033,  987, 1079, 1080,  774,
      775,  776,  777,  914,  778, 1118,  779,  780,  862, 1493,

     1129,  862,  863, 1493, 1290,  863,  864, 1493, 1031,  864,
      865, 1493, 1034,  865,  866, 1493, 1033,  866,  867, 1493,
     1055,  867, 1060, 1290,  791,  792,  793,  794, 1066,  795,
     1067,  796,  797,  879,  880,  881,  879, 1068, 1069, 1088,
     1093, 1070, 1099, 1034, 1100, 1036, 1101,  915,  916,  917,
      918, 1055,  919, 1060,  920,  921, 1493, 1070, 1469, 1066,
     1120, 1067, 1036, 1112, 1113, 1130, 1131, 1290, 1068, 1069,
     1088, 1093, 1290, 1099, 1301, 1100,  989, 1101, 1290,  989,
     1302,  653,  653,  653,  653,  653,  653,  653,  653,  653,
      653,  653,  653,  653,  653,  653,  653,  653,  653,  653,

      653,  653,  653,  653,  653,  653,  653,  656,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  879,  880,  881,  879, 1102,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656,  656,  656,  656,  656,  656,  656,
      656,  656,  656,  656, 1126, 1260, 1057, 1061, 1102,  731,
     1090, 1290,  740, 1015,  981, 1493, 1313,  981, 1290, 1062,
     1016, 1017, 1035,  740, 1018, 1019, 1036, 1020, 1063, 1058,
     1037, 1021, 1064, 1091, 1305, 1126, 1038, 1057, 1061, 1022,

      731, 1090, 1039,  740, 1013,  585, 1013, 1013, 1103, 1014,
     1062, 1023,  951, 1040,  740,  973, 1493, 1036,  973, 1063,
     1104, 1037, 1290, 1065, 1103,  981, 1493, 1038,  981,  951,
     1468, 1015, 1290, 1039, 1123, 1493, 1290, 1123, 1016, 1017,
     1290,  990, 1018, 1019,  990, 1020,  740, 1467,  993, 1021,
     1061,  993,  414,  859, 1059,  414, 1300, 1022, 1092, 1466,
      987, 1493, 1062,  987, 1089, 1024, 1025, 1026, 1027, 1023,
     1028, 1063, 1029, 1030, 1041, 1065, 1306,  740, 1075, 1453,
     1075, 1061, 1076, 1076, 1076, 1076, 1076, 1076, 1076, 1076,
     1076, 1133, 1006, 1062,  879,  880,  881,  879, 1160, 1180,

     1181, 1290, 1063, 1108, 1162, 1108, 1065, 1109, 1109, 1109,
     1109, 1109, 1109, 1109, 1109, 1109, 1163, 1199, 1208, 1209,
     1258, 1165,  957, 1024, 1025, 1026, 1027, 1290, 1028, 1160,
     1029, 1030, 1073, 1199, 1290, 1162, 1123, 1493, 1165, 1123,
     1074, 1074, 1074, 1074, 1452, 1184, 1303, 1163, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074, 1074,
     1074, 1074, 1074, 1074, 1094, 1094, 1184, 1164, 1189, 1195,
     1186, 1165, 1196, 1197, 1198, 1166, 1095, 1095, 1217, 1218,
     1221, 1167, 1218, 1195, 1219, 1096, 1096, 1168, 1195, 1097,

     1098, 1237, 1290, 1187, 1237, 1094, 1094, 1195, 1169, 1189,
     1195, 1186, 1165, 1196, 1197, 1198, 1166, 1095, 1095, 1217,
     1117, 1221, 1167, 1254, 1195, 1314, 1096, 1096, 1168, 1195,
     1098, 1098, 1142,  585, 1142, 1142, 1144, 1143, 1195, 1223,
     1451, 1290, 1220, 1145, 1146, 1450, 1290, 1147, 1148, 1224,
     1149, 1190, 1195, 1224, 1150, 1218, 1195, 1195, 1218, 1144,
     1219, 1195, 1151, 1191, 1227, 1195, 1145, 1146, 1188, 1170,
     1147, 1148, 1192, 1149, 1152, 1243, 1193, 1150, 1247, 1290,
     1224, 1258, 1190, 1195, 1224, 1151, 1443, 1195, 1195, 1190,
     1099, 1099, 1195, 1099, 1191, 1227, 1195, 1152, 1099, 1249,

     1309, 1191, 1441, 1192, 1440, 1290, 1243, 1194, 1220, 1247,
     1192, 1250, 1244, 1250, 1194, 1244, 1099, 1245, 1099, 1253,
     1190, 1099, 1099, 1430, 1099, 1238, 1239, 1303, 1153, 1154,
     1155, 1156, 1191, 1157, 1429, 1158, 1159, 1263, 1099, 1428,
     1263, 1192, 1250, 1271, 1250, 1194, 1290, 1099, 1427, 1099,
     1253, 1153, 1154, 1155, 1156, 1290, 1157, 1290, 1158, 1159,
     1202, 1123, 1493, 1262, 1123, 1246,  966,  967, 1203, 1203,
     1203, 1203,  414,  859, 1271,  414, 1203, 1203, 1203, 1203,
     1203, 1203, 1203, 1203, 1203, 1203, 1203, 1203, 1203, 1203,
     1203, 1203, 1203, 1203, 1203, 1203, 1203, 1203, 1203, 1203,

     1203, 1203, 1204,  959, 1204, 1290, 1205, 1205, 1205, 1205,
     1205, 1205, 1205, 1205, 1205, 1218,  960, 1110, 1218, 1244,
     1219, 1144, 1244, 1099, 1245, 1293, 1424, 1099, 1145, 1146,
     1295, 1294, 1147, 1148, 1294, 1149, 1099, 1319,  948, 1150,
     1320, 1263, 1225, 1296, 1263, 1226, 1290, 1230,  879,  880,
      881,  879, 1290, 1423, 1099, 1195, 1293, 1290, 1099, 1152,
     1346, 1264, 1265,  879,  880,  881,  879, 1099, 1220,  948,
     1099, 1111, 1246, 1225, 1112, 1113, 1226, 1205, 1205, 1205,
     1205, 1205, 1205, 1205, 1205, 1205, 1195, 1229, 1229, 1229,
     1229, 1229, 1229, 1229, 1229, 1229, 1229, 1229, 1229, 1229,

     1229, 1229, 1229, 1229, 1229, 1229, 1229, 1229, 1229, 1229,
     1229, 1229, 1229, 1153, 1154, 1155, 1156, 1144, 1157, 1410,
     1158, 1159, 1290, 1409, 1145, 1146,  782, 1244, 1147, 1148,
     1244, 1149, 1245,  783,  784, 1150, 1244,  785,  786, 1244,
      787, 1292, 1408, 1231,  788, 1278,  880, 1279, 1278,  963,
     1290,  964, 1256, 1290, 1251, 1152, 1093, 1252, 1281,  880,
     1282, 1281, 1312, 1290,  790, 1264, 1265, 1099, 1109, 1109,
     1109, 1109, 1109, 1109, 1109, 1109, 1109, 1290, 1290, 1290,
     1246, 1284,  880, 1285, 1284, 1251, 1290, 1093, 1252,  782,
      879,  880,  881,  879, 1407, 1290,  783,  784, 1099, 1088,

      785,  786,  946,  787,  949, 1099, 1405,  788, 1290, 1153,
     1154, 1155, 1156, 1290, 1157, 1257, 1158, 1159,  791,  792,
      793,  794, 1290,  795, 1290,  796,  797,  790, 1290, 1247,
     1088, 1401, 1290,  946, 1258,  949, 1099, 1290, 1090, 1307,
     1308, 1100, 1290, 1295,  740, 1244, 1310, 1311, 1244, 1243,
     1292, 1399, 1244, 1309, 1290, 1244, 1296, 1292, 1103,  782,
     1247, 1091,  951, 1099, 1290, 1101,  783,  784, 1290, 1090,
      785,  786, 1100,  787, 1103, 1102, 1290,  788, 1290,  951,
     1243,  791,  792,  793,  794,  789,  795, 1099,  796,  797,
      585,  585,  585,  585, 1099, 1291, 1101,  790, 1246,  950,

     1389, 1099, 1388,  951, 1385, 1246, 1102,  952, 1338, 1099,
     1099, 1250, 1290,  953, 1290, 1290, 1384,  782, 1099,  954,
     1290, 1310, 1311, 1339,  783,  784, 1092, 1290,  785,  786,
      955,  787, 1099, 1099,  951,  788, 1094, 1099,  952, 1099,
     1099, 1099, 1250,  789,  953, 1383, 1099, 1290, 1095, 1099,
      954,  791,  792,  793,  794,  790,  795, 1096,  796,  797,
     1290, 1097, 1290, 1381, 1099, 1298, 1294, 1094, 1099, 1294,
     1099, 1290, 1290, 1290, 1380, 1294, 1249, 1099, 1294, 1095,
     1099, 1379, 1298, 1307, 1308, 1290, 1378, 1299, 1096, 1293,
     1250,  956, 1098, 1108, 1094, 1108, 1298, 1109, 1109, 1109,

     1109, 1109, 1109, 1109, 1109, 1109, 1095, 1099, 1253,  791,
      792,  793,  794, 1298,  795, 1096,  796,  797, 1299, 1098,
     1293, 1250, 1376, 1290, 1244, 1094, 1290, 1244, 1244, 1292,
     1317, 1244, 1294, 1292, 1363, 1294, 1290, 1095, 1099, 1253,
     1340, 1341, 1328, 1290, 1090,  782, 1096, 1099, 1099, 1099,
     1098, 1251,  783,  784, 1252, 1362,  785,  786,  782,  787,
     1361, 1317, 1360,  788, 1099,  783,  784, 1099, 1299,  785,
      786, 1256,  787, 1328, 1290, 1090,  788, 1246, 1099, 1099,
     1099, 1246, 1251,  790, 1257, 1252, 1109, 1109, 1109, 1109,
     1109, 1109, 1109, 1109, 1109, 1099,  790, 1290, 1099, 1299,

     1244, 1386, 1493, 1244, 1387, 1245, 1281,  880, 1282, 1281,
     1493, 1493, 1493, 1493, 1244, 1244, 1358, 1244, 1244, 1245,
     1245, 1323,  880, 1279, 1323, 1323,  880, 1279, 1323, 1323,
      880, 1279, 1323, 1324,  880, 1282, 1324,  791,  792,  793,
      794, 1327,  795, 1136,  796,  797, 1324,  880, 1282, 1324,
      791,  792,  793,  794, 1099,  795,  740,  796,  797, 1324,
      880, 1282, 1324, 1325,  880, 1285, 1325, 1246, 1246, 1325,
      880, 1285, 1325, 1325,  880, 1285, 1325, 1343, 1311,  782,
     1323,  880, 1279, 1323, 1349, 1099,  783,  784, 1354, 1244,
      785,  786, 1244,  787, 1245, 1353, 1352,  788, 1324,  880,

     1282, 1324, 1331, 1351, 1331,  789, 1332, 1332, 1332, 1332,
     1332, 1332, 1332, 1332, 1332, 1349, 1334,  790, 1334, 1354,
     1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1325,
      880, 1285, 1325, 1332, 1332, 1332, 1332, 1332, 1332, 1332,
     1332, 1332, 1356, 1244, 1350, 1348, 1244, 1348, 1245, 1335,
     1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1244, 1244,
     1377, 1244, 1244, 1245, 1245, 1365, 1347, 1346, 1365, 1345,
     1366,  791,  792,  793,  794,  782,  795, 1344,  796,  797,
     1309, 1342,  783,  784, 1382,  740,  785,  786, 1402,  787,
      782, 1377, 1336,  788, 1333, 1329, 1357,  783,  784, 1327,

     1369,  785,  786, 1369,  787, 1370, 1326, 1322,  788, 1425,
     1321, 1246, 1246,  790, 1318, 1382,  740, 1316, 1367, 1402,
     1373, 1314, 1493, 1373, 1244, 1374, 1493, 1244,  790, 1245,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1369, 1390,
     1425, 1369, 1390, 1370, 1366, 1390, 1390, 1099, 1390, 1390,
     1366, 1366, 1390, 1371, 1313, 1390, 1393, 1366, 1312, 1393,
     1393, 1370, 1306, 1393, 1305, 1370, 1304,  791,  792,  793,
      794, 1303,  795, 1375,  796,  797, 1393, 1246, 1099, 1393,
     1303, 1370,  791,  792,  793,  794, 1302,  795, 1301,  796,
      797, 1371, 1367,  879,  880,  881,  879, 1393, 1367, 1367,

     1393, 1396, 1370, 1493, 1396, 1367, 1374, 1396, 1300, 1371,
     1396, 1089, 1374, 1371, 1391, 1396, 1396, 1297, 1396, 1396,
     1374, 1374,  879,  880,  881,  879, 1403, 1392, 1403, 1371,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1390,
     1393, 1290, 1390, 1393, 1366, 1370, 1244, 1290, 1289, 1244,
     1371, 1245, 1244, 1287, 1375, 1244, 1493, 1245, 1396, 1394,
     1375, 1396, 1286, 1374, 1493, 1493, 1493, 1493, 1375, 1375,
     1390, 1390, 1395, 1390, 1390, 1366, 1366, 1393, 1397, 1276,
     1393, 1275, 1370, 1274, 1390, 1393, 1273, 1390, 1393, 1366,
     1370, 1398, 1367, 1371, 1272, 1268, 1267, 1413, 1266, 1413,

     1262, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
     1261, 1375, 1260, 1259, 1400, 1390, 1258, 1110, 1390, 1099,
     1366, 1099, 1254, 1432, 1433, 1411, 1248, 1242, 1241, 1240,
     1435, 1236, 1235, 1412, 1412, 1412, 1412, 1367, 1436, 1234,
     1233, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412, 1412,
     1412, 1412, 1412, 1412, 1412, 1412, 1412, 1232, 1367, 1393,
     1396, 1206, 1393, 1396, 1370, 1374, 1195, 1396, 1244, 1415,
     1396, 1244, 1374, 1245, 1195, 1228, 1222, 1416, 1416, 1416,
     1416, 1216, 1215, 1214, 1213, 1416, 1416, 1416, 1416, 1416,

     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416, 1416,
     1416, 1393, 1371, 1438, 1393, 1212, 1370, 1211, 1210, 1201,
     1439, 1246, 1200, 1185, 1417, 1183, 1417, 1182, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1418, 1418, 1396, 1364, 1179,
     1396, 1176, 1374, 1152, 1175, 1172, 1364, 1364, 1364, 1364,
     1421, 1171, 1421, 1161, 1422, 1422, 1422, 1422, 1422, 1422,
     1422, 1422, 1422, 1368, 1371, 1396, 1139, 1138, 1396, 1138,
     1374, 1368, 1368, 1368, 1368, 1419, 1244, 1390, 1137, 1244,
     1390, 1245, 1366, 1420, 1420, 1420, 1420, 1136, 1135, 1442,

     1375, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420, 1420,
     1420, 1420, 1420, 1420, 1420, 1420, 1420, 1134, 1375, 1404,
     1404, 1404, 1404, 1404, 1404, 1404, 1404, 1404, 1390, 1246,
     1367, 1390, 1372, 1366, 1004, 1132, 1364, 1127, 1493, 1391,
     1372, 1372, 1372, 1372, 1364, 1364, 1364, 1364, 1493, 1493,
     1493, 1120, 1444, 1119, 1431, 1431, 1431, 1431, 1431, 1431,
     1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431,
     1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431, 1431,
     1390, 1367, 1118, 1390, 1117, 1366, 1116, 1115, 1390, 1393,

     1114, 1390, 1393, 1366, 1370, 1106, 1105, 1414, 1414, 1414,
     1414, 1414, 1414, 1414, 1414, 1414, 1418, 1418, 1418, 1418,
     1418, 1418, 1418, 1418, 1418, 1368, 1104, 1089, 1087, 1372,
     1086, 1085, 1084, 1368, 1368, 1368, 1368, 1372, 1372, 1372,
     1372, 1083, 1082, 1367, 1393, 1081, 1072, 1393, 1071, 1370,
     1056, 1433, 1371, 1390, 1054, 1053, 1390, 1393, 1366, 1050,
     1393, 1393, 1370, 1047, 1393, 1023, 1370, 1046, 1043, 1042,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434, 1434,
     1434, 1434, 1434, 1434, 1434, 1434, 1032, 1371, 1396, 1010,

     1009, 1396, 1008, 1374, 1390, 1007, 1432, 1390, 1001, 1366,
     1436, 1000,  999,  998, 1435,  998,  997,  730,  994,  880,
     1493, 1493, 1493, 1493, 1437, 1437, 1437, 1437, 1437, 1437,
     1437, 1437, 1437, 1437, 1437, 1437, 1437, 1437, 1437, 1437,
     1437, 1437, 1437, 1437, 1437, 1437, 1437, 1437, 1437, 1437,
     1396, 1375, 1493, 1396, 1493, 1374, 1393, 1367,  969, 1393,
     1393, 1370,  968, 1393,  965, 1370, 1445, 1422, 1422, 1422,
     1422, 1422, 1422, 1422, 1422, 1422,  962, 1396,  790, 1392,
     1396, 1396, 1374,  961, 1396, 1396, 1374,  958, 1396,  957,
     1374, 1396,  947,  945, 1396,  944, 1374,  941,  938,  914,

      937,  934,  933, 1375,  923,  901,  900,  899,  898, 1371,
      894,  893,  892, 1371,  891,  890,  747,  740, 1394,  740,
      889,  883, 1447,  874,  872,  871,  868,  868,  689,  857,
     1375, 1446, 1493, 1493, 1375, 1395, 1493, 1493, 1439, 1397,
     1493, 1493, 1390, 1449, 1438, 1390,  842, 1366,  842,  840,
      840,  841, 1448,  839, 1493, 1454, 1398, 1454,  805, 1455,
     1455, 1455, 1455, 1455, 1455, 1455, 1455, 1455,  799,  799,
      762,  762,  760,  760,  758,  757,  756,  755,  754,  753,
      752,  751,  746,  745,  730,  553,  550,  725,  721,  720,
      719,  718,  717,  717,  710, 1367, 1456, 1493,  311,  694,

      693,  692,  495,  691, 1457, 1457, 1457, 1457,  686,  686,
     1493, 1493, 1457, 1457, 1457, 1457, 1457, 1457, 1457, 1457,
     1457, 1457, 1457, 1457, 1457, 1457, 1457, 1457, 1457, 1457,
     1457, 1457, 1457, 1457, 1457, 1457, 1457, 1457, 1393, 1493,
      645, 1393, 1493, 1370, 1493, 1493,  463, 1493,  602,  602,
      601, 1458,  601, 1458,  593, 1459, 1459, 1459, 1459, 1459,
     1459, 1459, 1459, 1459,  592,  591,  590,  589,  588,  587,
      583,  583,  581,  581,  578,  577,  576,  573,  570,  375,
      569,  568,  567,  557,  366,  363,  551,  550,  355,  544,
      543, 1371, 1460,  542,  541,  540,  539,  533,  533,  532,

     1461, 1461, 1461, 1461,  532,  528,  527,  525, 1461, 1461,
     1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461,
     1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461, 1461,
     1461, 1461, 1461, 1461, 1396,  524,  521, 1396,  152, 1374,
      311,  504,  504,  499,  499,  497,  497, 1462,  498, 1462,
      496, 1463, 1463, 1463, 1463, 1463, 1463, 1463, 1463, 1463,
      494,  291,  488,  483,  482,  479,  470,  466,  463, 1493,
      406,  404,  402,  227,  225,  220,  390,  386,  388,  386,
      384,  383,  208,  202,  205,  204,  195, 1375, 1464,  204,
      349,  348,  347,  346,  345,  344, 1465, 1465, 1465, 1465,

      331,  152,  305,  303, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465, 1465,
     1390,  300,  299, 1390,  278, 1366,  277,  239,  125,  124,
      239,  104,  224,  223,  213,  212,  211, 1455, 1455, 1455,
     1455, 1455, 1455, 1455, 1455, 1455,  210, 1393,  205,  204,
     1393,  200, 1370,  188,  186,  184,  182,  181,  180,  179,
      173,  171,  161,  160, 1459, 1459, 1459, 1459, 1459, 1459,
     1459, 1459, 1459, 1367, 1470, 1470, 1470, 1470, 1470, 1470,
     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,

     1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
     1371, 1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471,
     1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471, 1471,
     1471, 1471, 1471, 1471, 1471, 1471, 1471, 1396,  156,  127,
     1396,  125, 1374,  124,  108, 1493,  102,  102,   38,   38,
     1493, 1493, 1493, 1493, 1463, 1463, 1463, 1463, 1463, 1463,
     1463, 1463, 1463, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1375, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,

     1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472, 1472,
     1472, 1472, 1472, 1472, 1472, 1472, 1472,   38,   38,   38,
       38,   38,   38,   38,   38,   38,   38,   38,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   56,
       56,   56,   56,   56,   56,   56,   56,   56,   56,   56,
       68,   68,   68,   68,   68,   68,   68,   68,   68,   68,
       68,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,   73,   42,   42,   42,   42,   42,   42,   42,   42,
       42,   42,   42,   90,   90,   90,   90,   90,   90,   90,
       90,   90,   90,   90,   94,   94,   94,   94,   94,   94,

       94,   94,   94,   94,   94,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,  101,  101,  101,  101,
      101,  101,  101,  101,  101,  101,  101,  114,  114,  114,
      114,  114,  114,  114,  114,  114,  114,  114,  128,  128,
      128,  128,  162,  162, 1493,  162,  162,  162,  162,  162,
      162,  162,  162,  172, 1493, 1493, 1493,  172,  172,  172,
      172,  172,  172,  172,  177,  177, 1493, 1493,  177,  177,
      177,  177,  177,  177,  177,  183,  183, 1493,  183,  183,
      183,  183,  183,  183,  183,  183,  185, 1493, 1493, 1493,
      185,  185,  185,  185,  185,  185,  185,  187, 1493, 1493,

     1493,  187,  187,  187,  187,  187,  187,  187,  189, 1493,
     1493, 1493,  189,  189,  189,  189,  189,  189,  189,  206,
      206, 1493,  206,  206,  206,  206,  206,  206,  206,  206,
      214,  214, 1493,  214,  214,  214,  214,  214,  214,  214,
      214,  219,  219, 1493,  219,  219,  219,  219,  219,  219,
      219,  219,  229,  229, 1493,  229,  229,  229,  229,  229,
      229,  229,  229,  245,  245,  245,  245,  245,  245,  245,
      245,  245,  245,  245,  128,  128,  128,  128,  280,  280,
     1493,  280,  280,  280,  280,  280,  280,  280,  280,  282,
      282, 1493,  282,  282,  282,  282,  282,  282,  282,  282,

      290,  290, 1493,  290,  290,  290,  290,  290,  290,  290,
      290,  295,  295, 1493,  295,  295,  295,  295,  295,  295,
      295,  295,  301, 1493,  301,  301,  302,  302,  304, 1493,
     1493,  304,  304,  172, 1493, 1493, 1493,  172,  172,  172,
      172,  172,  172,  172,  177,  177, 1493, 1493,  177,  177,
      177,  177,  177,  177,  177,  183,  183, 1493,  183,  183,
      183,  183,  183,  183,  183,  183,  185, 1493, 1493, 1493,
      185,  185,  185,  185,  185,  185,  185,  187, 1493, 1493,
     1493,  187,  187,  187,  187,  187,  187,  187,  189, 1493,
     1493, 1493,  189,  189,  189,  189,  189,  189,  189,  353,

      353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
      362,  362, 1493,  362,  362,  362,  362,  362,  362,  362,
      362,  385,  385, 1493,  385,  385,  385,  385,  385,  385,
      385,  385,  387,  387, 1493,  387,  387,  387,  387,  387,
      387,  387,  387,  219,  219, 1493,  219,  219,  219,  219,
      219,  219,  219,  219,  229,  229, 1493,  229,  229,  229,
      229,  229,  229,  229,  229,  414,  414,  414,  414,  414,
      414,  414,  414,  414,  414,  414,  290,  290, 1493,  290,
      290,  290,  290,  290,  290,  290,  290,  493,  493, 1493,
      493,  493,  493,  493,  493,  493,  493,  493,  280,  280,

     1493,  280,  280,  280,  280,  280,  280,  280,  280,  495,
      495, 1493,  495,  495,  495,  495,  495,  495,  495,  495,
      500,  500, 1493,  500,  500,  500,  500,  500,  500,  500,
      500,  501,  501, 1493,  501,  501,  501,  501,  501,  501,
      501,  501,  502,  502,  502,  502,  502, 1493,  502,  502,
      502,  502,  502,  503,  503, 1493,  503,  503,  503,  503,
      503,  503,  503,  503,  506,  506,  507,  507,  507,  507,
     1493,  507,  507,  507,  507,  507,  507,  508,  508,  508,
      508,  508, 1493,  508,  508,  508,  508,  508,  545,  545,
     1493,  545,  545,  545,  545,  545,  545,  545,  545,  353,

      353,  353,  353,  353,  353,  353,  353,  353,  353,  353,
      552,  552, 1493,  552,  552,  552,  552,  552,  552,  552,
      552,  579,  579, 1493,  579,  579,  579,  579,  579,  579,
      579,  579,  580,  580, 1493,  580,  580,  580,  580,  580,
      580,  580,  580,  582,  582, 1493,  582,  582,  582,  582,
      582,  582,  582,  582,  586,  586, 1493,  586,  586,  586,
      586,  586,  586,  586,  586,  594,  594, 1493,  594,  594,
      594,  594,  594,  594,  594,  594,  229,  229, 1493,  229,
      229,  229,  229,  229,  229,  229,  229,  634,  634, 1493,
      634,  634,  634,  634,  634,  634,  634,  634,  636,  636,

     1493,  636,  636,  636,  636,  636,  636,  636,  636,  644,
      644, 1493,  644,  644,  644,  644,  644,  644,  644,  644,
      680,  680, 1493,  680,  680,  680,  680,  680,  680,  680,
      680,  684,  684, 1493,  684,  684,  684,  684,  684,  684,
      684,  684,  493,  493, 1493,  493,  493,  493,  493,  493,
      493,  493,  493,  689,  689, 1493,  689,  689,  689,  689,
      689,  689,  689,  689,  690,  690, 1493,  690,  690,  690,
      690,  690,  690,  690,  690,  502,  502,  502,  502,  502,
      502,  502,  502,  502,  502,  502,  304,  304,  507,  507,
      507,  507,  507,  507,  507,  507,  507,  507,  507,  508,

      508,  508,  508,  508,  508,  508,  508,  508,  508,  508,
      636,  636, 1493,  636,  636,  636,  636,  636,  636,  636,
      636,  545,  545, 1493,  545,  545,  545,  545,  545,  545,
      545,  545,  728,  728, 1493,  728,  728,  728,  728,  728,
      728,  728,  728,  579,  579, 1493,  579,  579,  579,  579,
      579,  579,  579,  579,  759,  759, 1493,  759,  759,  759,
      759,  759,  759,  759,  759,  761,  761, 1493,  761,  761,
      761,  761,  761,  761,  761,  761,  798,  798, 1493,  798,
      798,  798,  798,  798,  798,  798,  798,  594,  594, 1493,
      594,  594,  594,  594,  594,  594,  594,  594,  800,  800,

     1493,  800,  800,  800,  800,  800,  800,  800,  800,  801,
      801, 1493,  801,  801,  801,  801,  801,  801,  801,  801,
      229,  229, 1493,  229,  229,  229,  229,  229,  229,  229,
      229,  802,  802, 1493,  802,  802,  802,  802,  802,  802,
      802,  802,  803,  803, 1493,  803,  803,  803,  803,  803,
      803,  803,  803,  804,  804, 1493,  804,  804,  804,  804,
      804,  804,  804,  804,  812,  812, 1493,  812,  812,  812,
      812,  812,  812,  812,  812,  832,  832, 1493,  832,  832,
      832,  832,  832,  832,  832,  832,  836,  836, 1493,  836,
      836,  836,  836,  836,  836,  836,  836,  634,  634, 1493,

      634,  634,  634,  634,  634,  634,  634,  634,  838,  838,
     1493,  838,  838,  838,  838,  838,  838,  838,  838,  843,
      843, 1493,  843,  843,  843,  843,  843,  843,  843,  843,
      844,  844,  844,  844,  844,  844,  844,  844,  844,  844,
      844,  848,  848,  848,  848,  848,  848,  848,  848,  848,
      848,  848,  849,  849,  849,  849,  849,  849,  849,  849,
      849,  849,  849,  850,  850, 1493,  850,  850,  850,  850,
      850,  850,  850,  850,  851,  851, 1493,  851,  851,  851,
      851,  851,  851,  851,  851,  852,  852, 1493,  852,  852,
      852,  852,  852,  852,  852,  852,  853,  853, 1493,  853,

      853,  853,  853,  853,  853,  853,  853,  854,  854, 1493,
      854,  854,  854,  854,  854,  854,  854,  854,  855,  855,
     1493,  855,  855,  855,  855,  855,  855,  855,  855,  680,
      680, 1493,  680,  680,  680,  680,  680,  680,  680,  680,
      856,  856, 1493,  856,  856,  856,  856,  856,  856,  856,
      856,  684,  684, 1493,  684,  684,  684,  684,  684,  684,
      684,  684,  859, 1493,  859,  859,  859,  859,  859,  859,
      859,  859,  859,  838,  838, 1493,  838,  838,  838,  838,
      838,  838,  838,  838,  545,  545,  545,  545,  545,  545,
      545,  545,  545,  545,  545,  877,  877, 1493,  877,  877,

      877,  877,  877,  877,  877,  877,  902,  902, 1493,  902,
      902,  902,  902,  902,  902,  902,  902,  759,  759, 1493,
      759,  759,  759,  759,  759,  759,  759,  759,  903,  903,
     1493,  903,  903,  903,  903,  903,  903,  903,  903,  761,
      761, 1493,  761,  761,  761,  761,  761,  761,  761,  761,
      970,  970, 1493,  970,  970,  970,  970,  970,  970,  970,
      970,  798,  798, 1493,  798,  798,  798,  798,  798,  798,
      798,  798,  800,  800, 1493,  800,  800,  800,  800,  800,
      800,  800,  800,  801,  801, 1493,  801,  801,  801,  801,
      801,  801,  801,  801,  802,  802, 1493,  802,  802,  802,

      802,  802,  802,  802,  802,  803,  803, 1493,  803,  803,
      803,  803,  803,  803,  803,  803,  804,  804, 1493,  804,
      804,  804,  804,  804,  804,  804,  804,  812,  812, 1493,
      812,  812,  812,  812,  812,  812,  812,  812,  974,  974,
     1493,  974,  974,  974,  974,  974,  974,  974,  974,  975,
      975, 1493,  975,  975,  975,  975,  975,  975,  975,  975,
      976,  976, 1493,  976,  976,  976,  976,  976,  976,  976,
      976,  977,  977, 1493,  977,  977,  977,  977,  977,  977,
      977,  977,  978,  978, 1493,  978,  978,  978,  978,  978,
      978,  978,  978,  979,  979, 1493,  979,  979,  979,  979,

      979,  979,  979,  979,  832,  832, 1493,  832,  832,  832,
      832,  832,  832,  832,  832,  980,  980, 1493,  980,  980,
      980,  980,  980,  980,  980,  980,  836,  836, 1493,  836,
      836,  836,  836,  836,  836,  836,  836,  982,  982, 1493,
      982,  982,  982,  982,  982,  982,  982,  982,  844,  844,
      844,  844,  844,  844,  844,  844,  844,  844,  844,  848,
      848,  848,  848,  848,  848,  848,  848,  848,  848,  848,
      849,  849,  849,  849,  849,  849,  849,  849,  849,  849,
      849,  850,  850, 1493,  850,  850,  850,  850,  850,  850,
      850,  850,  851,  851, 1493,  851,  851,  851,  851,  851,

      851,  851,  851,  852,  852, 1493,  852,  852,  852,  852,
      852,  852,  852,  852,  853,  853, 1493,  853,  853,  853,
      853,  853,  853,  853,  853,  854,  854, 1493,  854,  854,
      854,  854,  854,  854,  854,  854,  855,  855, 1493,  855,
      855,  855,  855,  855,  855,  855,  855,  856,  856, 1493,
      856,  856,  856,  856,  856,  856,  856,  856,  859, 1493,
      859,  859,  859,  859,  859,  859,  859,  859,  859,  991,
      991, 1493,  991,  991,  991,  991,  991,  991,  991,  991,
     1011, 1011, 1493, 1011, 1011, 1011, 1011, 1011, 1011, 1011,
     1011, 1012, 1012, 1493, 1012, 1012, 1012, 1012, 1012, 1012,

     1012, 1012, 1107, 1493, 1107, 1107, 1121, 1121, 1493, 1121,
     1121, 1121, 1121, 1121, 1121, 1121, 1121,  974,  974, 1493,
      974,  974,  974,  974,  974,  974,  974,  974,  975,  975,
     1493,  975,  975,  975,  975,  975,  975,  975,  975,  976,
      976, 1493,  976,  976,  976,  976,  976,  976,  976,  976,
      977,  977, 1493,  977,  977,  977,  977,  977,  977,  977,
      977,  978,  978, 1493,  978,  978,  978,  978,  978,  978,
      978,  978,  979,  979, 1493,  979,  979,  979,  979,  979,
      979,  979,  979,  980,  980, 1493,  980,  980,  980,  980,
      980,  980,  980,  980, 1124, 1124, 1124, 1124, 1124, 1124,

     1124, 1124, 1124, 1124, 1124, 1125, 1125, 1493, 1125, 1125,
     1125, 1125, 1125, 1125, 1125, 1125, 1140, 1140, 1493, 1140,
     1140, 1140, 1140, 1140, 1140, 1140, 1140, 1141, 1141, 1493,
     1141, 1141, 1141, 1141, 1141, 1141, 1141, 1141, 1269, 1269,
     1493, 1269, 1269, 1269, 1269, 1269, 1269, 1269, 1269, 1270,
     1270, 1493, 1270, 1270, 1270, 1270, 1270, 1270, 1270, 1270,
     1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277, 1277,
     1277, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280, 1280,
     1280, 1280, 1283, 1283, 1283, 1283, 1283, 1283, 1283, 1283,
     1283, 1283, 1283, 1288, 1288, 1493, 1288, 1288, 1288, 1288,

     1288, 1288, 1288, 1288, 1107, 1493, 1107, 1493, 1107, 1107,
     1315, 1315, 1493, 1315, 1315, 1315, 1315, 1315, 1315, 1315,
     1315, 1330, 1493, 1330, 1330, 1337, 1493, 1337, 1337, 1364,
     1364, 1493, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
     1368, 1368, 1493, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
     1368, 1372, 1372, 1493, 1372, 1372, 1372, 1372, 1372, 1372,
     1372, 1372, 1406, 1493, 1406, 1406,   37, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,

     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493

    } ;

static const flex_int16_t yy_chk[7497] =
    {   0,
        0,    0,    3,    3,    4,    4,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,

        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
        5,    5,    5,    5,    5,    7,    7,    7,    7,    8,
        8,    8,    8,   15,    9,   10,   25,   25,   25,   25,
        7,   27,   27,   27,    8,   26,   26,   26,   26,  250,
       25,   25,    9,   10,   28,   28,   28,   29,   30,   26,
       26,   33,   33,  250,   29,   30,   34,   34,   15, 1676,
       48,   29,   30,   48,   15,  378,   15,  378,    7,    9,
       10,   59,    8,  233,   59,   40,   40,   40,   40,   25,

      233,   25,   66,   66,   40,   66,   87,   87,   26,   15,
       26,   40,  776,   67,  776,   15,   67,   15,  284,  284,
        9,   10,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       16,   43,   43,   43,   43,  260,  135,   55,   44,   44,
       44,   44,   55,  368,  260,   43,   43,   44,   44,   86,

       86,   86,   86,   44,   44,   60,   60,   60,   60,   60,
       60,   60,   99,   99, 1671,   16,   91,   91,   91,   91,
      370,   16,  111,   16,  368,  111, 1670,   99,  135,   55,
      103,  103,  103,  103,   43,  104,  104,  126,  269,  127,
      126,   44,  127,  104,  136,  139,   16,  136,  139,  269,
      104,  370,   16,  139,   16,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,

       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
       19,   19,   19,   19,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,

       21,   21,   21,   21,   21,   21,   21,   21,   21,   21,
       21,   21,   21,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,

       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
       23,   23,   45,   45,   45,   45,  164,  122,  321,  164,
      371,  122,  150,   52,  122,  130,   52,   45,  130,  321,
       53,   53,   53,   53,  248,   83,  150,   52,   83,   53,
       53,   84,   84,   84,   84,  138,   53,  436,  138,   83,
       83,  371,  249,  148,  138,   97,  148,  165,   97,  845,
      165,  122,  148,  296,  296,   45,   51,   51,   51,   51,

       51,   51,   51,   51,   51,   51,   52,   51,  130,  197,
       51,   51,   51,   53,  166,   84,  248,  166,   83,  108,
      108,  108,  108,  513,   84,  150,   84,   97,  108,  197,
     1156,  113,   51,  150,  249,  108,   97,  155,  113,  155,
      197,  155,  845,  113,  155,  113,  167,   51,   51,  167,
      436,   51,   51,   51,   51,   51,   51,   51,   97,   51,
      197,  168,   51,   51,  168,   51,   51,   51,  417,   51,
       51,   51,   51,   51,   51,   51,  107,   51,   51,   51,
      113,  155,  417,  107,  109,  109,  109,  109,  107,  270,
      270,  270,  107,  107,  107,  513,  107,  437,  109,  109,

      110,  110,  110,  110,  113,  115,  115,  115,  115,  433,
      169,  107,  113,  169,  454,  110,  116,  116,  116,  116,
      115,  311,  311, 1659,  107,  116,  116,  117,  117,  117,
      117,  116,  116,  159, 1156,  149,  159,  109,  149, 1570,
      170,  159,  117,  170,  511,  123,  123,  123,  123,  149,
      325,  325,  514,  110,  123,  123,  177,  437,  115,  177,
      123,  123,  421,  151,  151,  151,  151,  328,  328,  116,
      132,  132,  132,  132,  132,  132,  132,  132,  433,  134,
      117,  121,  121,  134,  121,  134,  134,  178,  149,  454,
      178,  134,  162,  162,  162,  162,  134,  121,  123,  134,

      426,  152,  152,  152,  152,  420,  220,  220,  121,  420,
      152,  152,  223,  223,  121,  121,  151,  152,  121,  511,
      121,  220,  121,  440,  121,  121,  121,  223,  121,  163,
      121,  514,  163,  896,  121,  191,  191,  191,  191,  121,
      426,  121,  236,  121,  421,  236,  121,  163,  163,  163,
      163,  121,  896,  147,  152,  147,  121,  147,  147,  147,
      147,  147,  147,  147,  147,  147,  154,  154,  647,  154,
     1209,  154,  156,  156,  156,  156,  647,  227,  227,  154,
      154,  156,  156,  157,  440,  227,  154,  157,  156,  157,
      157,  190,  227, 1211,  190,  157,  192,  192,  192,  192,

      157,  194, 1150,  157,  194,  190,  190,  195,  195,  195,
      195,  192,  200,  200,  200,  200,  194,  201,  201,  201,
      201,  202,  202,  202,  202,  156,  204,  217,  733,  204,
      207,  207,  207,  207,  380,  380,  208,  208,  208,  208,
      210,  210,  210,  210,  190,  733,  222,  238,  222,  230,
      239,  195,  230,  239,  194,  217,  200,  222,  238,  222,
      195,  222,  195,  208,  238,  200,  217,  200,  222, 1209,
      208,  208,  217,  231,  208,  208,  231,  208,  238,  204,
     1211,  208,  234,  230,  253,  253,  217,  253,  234,  238,
      408,  408,  230,  234,  222,  238, 1152,  217,  460,  234,

      231,  208,  460,  217,  240,  234,  241,  240,  265,  241,
      256,  265,  240,  256,  241, 1150,  231,  275,  261,  234,
      275,  261,  231,  242,  242,  242,  242,  411,  411,  428,
      234,  243,  243,  243,  243, 1152,  234,  516,  242,  244,
      244,  244,  244,  649,  256,  258,  243,  261,  258,  246,
      246,  246,  246,  256,  244,  208,  208,  208,  208,  261,
      208,  569,  208,  208,  246,  247,  247,  247,  247,  428,
      262,  276,  258,  262,  276,  279,  242,  262,  279,  276,
      247,  793,  272,  793,  243,  650,  258,  262,  258,  263,
      490,  490,  244,  272,  258,  263,  529,  529,  293,  272,

      263,  293,  246,  570,  570,  308,  263,  293,  308,  517,
      638,  638,  263,  272,  308,  569,  516,  606,  247,  251,
      251,  272,  251,  649,  272,  331,  263,  606,  331,  332,
      272, 1201,  332,  313,  313,  251,  313,  263,  310,  310,
      310,  310,  324,  263,  333,  324,  251,  333,  334,  650,
      324,  334,  251,  251,  335,  657,  251,  335,  251,  657,
      251,  556,  251,  251,  251, 1201,  251,  336,  251,  696,
      336,  337,  251,  338,  337,  339,  338,  251,  339,  251,
      340,  251,  341,  340,  251,  341,  313,  342,  517,  251,
      342,  310,  556,  708,  251,  252,  252,  252,  252,  252,

      252,  252,  252,  252,  252,  343,  252, 1158,  343,  252,
      252,  252,  306,  306,  306,  306,  306,  306,  306,  306,
      306,  350,  350,  350,  350,  351,  351,  351,  351,  399,
      352,  252,  399,  352,  354,  661, 1548,  354,  361,  361,
      361,  361, 1059,  661,  559,  352,  252,  252,  696,  354,
      252,  252,  252,  252,  252,  252,  252,  708,  252, 1059,
      318,  252,  252,  318,  252,  252,  252,  438,  252,  252,
      252,  252,  252,  252,  252,  559,  252,  252,  252,  315,
      315,  400,  315,  352,  400,  401,  402,  354,  401,  402,
      355,  355,  355,  355,  318,  315,  389,  389,  389,  389,

      707,  389, 1539,  318,  403,  315,  315,  403,  315, 1158,
      315,  404,  315,  315,  404,  558,  315,  808,  315,  315,
      315,  561,  315,  315,  315,  315,  315,  405,  315,  807,
      405,  438,  315,  406,  355,  318,  406,  315,  558,  315,
      318,  315,  438,  355,  315,  355,  558,  357,  407,  315,
      465,  407,  561,  465,  315,  316,  316,  316,  316,  316,
      316,  316,  316,  316,  316,  466,  316,  357,  466,  316,
      316,  316,  703,  703,  415,  415,  415,  415,  357,  811,
      707,  808,  416,  416,  416,  416,  429,  422,  422,  415,
      422,  316,  562,  418,  418,  418,  418,  416,  357,  423,

      423,  467,  423,  558,  467, 1492,  316,  316,  418,  807,
      316,  316,  316,  316,  316,  316,  316,  468,  316,  434,
      468,  316,  316,  562,  316,  316,  316,  415,  316,  316,
      316,  316,  316,  316,  316,  416,  316,  316,  316,  363,
      363,  363,  363,  811,  469,  429,  418,  469,  365,  365,
      365,  365,  450,  450,  429,  450,  419,  470,  419,  439,
      470,  366,  366,  366,  366,  419,  363,  563,  471, 1491,
      419,  471,  419,  363,  363,  365,  434,  363,  363,  434,
      363, 1145,  365,  365,  363,  515,  365,  365,  366,  365,
      772,  425,  425,  365,  425,  366,  366,  372,  563,  366,

      366,  372,  366,  772,  363,  372,  366,  419,  778,  778,
      789,  372,  431,  365, 1145,  430,  430,  372,  430,  439,
      439,  439,  810,  789,  464,  425,  366,  464,  372,  464,
      441,  419,  372,  917,  425,  917,  372,  472,  431,  419,
      472,  431,  372,  473,  430,  431,  473,  869,  372,  427,
      427,  474,  427,  515,  474,  431,  430,  937,  363,  363,
      363,  363,  441,  363,  515,  363,  363,  365,  365,  365,
      365,  432,  365,  441,  365,  365,  427, 1172,  453,  441,
      366,  366,  366,  366, 1490,  366,  564,  366,  366,  372,
      427,  475,  427,  441,  475, 1489,  476,  432,  427,  476,

      869,  441,  810,  432,  441,  445,  443,  443,  432,  443,
      441,  937,  452,  452,  432,  452,  477,  564, 1488,  477,
      432,  452,  445,  445,  445,  445,  445,  445,  445,  445,
      462,  462,  478,  462,  432,  478,  448,  913,  453,  462,
      448,  453,  448,  448,  479,  432,  453,  479,  448,  461,
      913,  432,  435,  448,  480,  481,  448,  480,  481,  443,
      848,  461, 1172,  461,  848,  461,  461,  461,  461,  461,
      461,  461,  461,  461,  795,  795, 1487,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,

      435,  435,  435,  457,  482,  485,  486,  482,  485,  486,
     1486,  457,  457,  457,  457,  487,  895,  895,  487,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  457,  457,  457,  457,  457,
      457,  457,  457,  457,  457,  458,  458,  458,  458,  458,
      458,  458,  458,  458,  458,  458,  458,  458,  458,  458,
      458,  458,  458,  458,  458,  458,  458,  458,  458,  458,
      458,  489,  494, 1216,  489,  494,  458,  458,  458,  458,
      458,  458,  458,  458,  458,  458,  458,  458,  458,  458,
      458,  458,  458,  458,  458,  458,  458,  458,  458,  458,

      458,  458,  459,  497,  521,  523,  497,  521,  523,  524,
      525,  526,  524,  525,  526,  729,  731, 1153,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  520,  527,  729,  731,  527,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  459,  459,  459,  459,  459,
      459,  459,  459,  459,  459,  483, 1485,  528,  483,  510,
      528,  510, 1484,  512,  512,  518,  512,  534,  603,  518,
      534,  518,  518,  483, 1216,  510,  535,  518,  536,  535,

      537,  536,  518,  537,  520,  518,  538,  520,  542,  538,
      543,  542,  520,  543, 1483,  546,  844,  512,  546,  547,
      547,  547,  547, 1153,  844,  550,  512,  542,  550,  597,
      546,  566,  597,  601,  547,  566,  601, 1177,  607,  607,
      483,  607,  553,  553,  553,  553,  666,  566,  603,  666,
      667,  603,  566,  667,  510,  604,  603,  648,  512,  734,
      999,  560,  510,  512,  555,  555,  555,  555,  546,  553,
      735,  609,  609,  560,  609,  999,  553,  553,  550,  972,
      553,  553,  560,  553, 1154,  565,  560,  553,  897,  897,
      734,  555,  560,  610,  610, 1159,  610,  565,  555,  555,

      849,  735,  555,  555,  560,  555,  565,  553,  849,  555,
      565,  611,  611,  560,  611,  604,  565,  560,  604,  608,
      608, 1482,  608,  604,  608,  648,  648, 1481,  565,  555,
      612,  612,  972,  612,  737,  613,  613,  565,  613,  614,
      614,  565,  614,  615,  615,  739,  615,  616,  616,  741,
      616,  617,  617, 1177,  617,  618,  618,  668,  618, 1022,
      668,  553,  553,  553,  553,  737,  553,  706,  553,  553,
      619,  619, 1022,  619,  620,  620,  739,  620,  621,  621,
      741,  621, 1215,  555,  555,  555,  555,  743,  555, 1159,
      555,  555,  584,  584,  584,  584, 1154,  584,  622,  622,

     1222,  622,  623,  623, 1222,  623,  624,  624, 1178,  624,
      625,  625, 1234,  625,  626,  626, 1188,  626,  743,  584,
      627,  627,  669,  627, 1092,  669,  584,  584,  961,  670,
      584,  584,  670,  584, 1179,  706,  706,  584,  627,  629,
      629, 1092,  629,  630,  630,  584,  630,  631,  631,  658,
      631,  633,  633, 1480,  633,  646,  646,  584,  646,  673,
      674, 1046,  673,  674,  646,  658,  658,  658,  658,  658,
      658,  658,  658,  658,  660,  660,  676,  660,  677,  676,
     1182,  677,  961,  660,  678,  627,  679,  678,  682,  679,
      683,  682,  685,  683,  687,  685,  688,  687,  692,  688,

     1188,  692,  695,  695, 1215,  695,  697,  697, 1026,  697,
     1026,  584,  584,  584,  584, 1046,  584, 1188,  584,  584,
      585,  585,  585,  585, 1178,  585,  698,  698, 1234,  698,
      699,  699, 1479,  699,  700,  700, 1179,  700,  701,  701,
     1478,  701,  702,  702, 1477,  702,  709,  585,  710,  709,
      711,  710, 1214,  711,  585,  585,  738,  712,  585,  585,
      712,  585, 1182,  713,  714,  585,  713,  714,  715,  716,
      738,  715,  716,  585,  720,  722,  723,  720,  722,  723,
      724,  725,  744,  724,  725,  585,  726,  726,  726,  726,
      727,  727,  727,  727,  730,  730,  730,  730,  765,  736,

      767,  738,  768,  736,  740,  740,  740,  740,  805,  919,
      919,  805,  736,  744,  782,  813,  813, 1476,  813,  784,
      785,  818,  818, 1207,  818,  819,  819, 1173,  819,  765,
      736,  767, 1173,  768,  736,  820,  820, 1161,  820,  585,
      585,  585,  585,  736,  585,  782,  585,  585,  652,  754,
      784,  785,  754,  821,  821,  857,  821,  806,  857,  809,
      822,  822, 1161,  822,  825,  825, 1475,  825,  826,  826,
     1214,  826, 1474,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  655,

      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  806,  806,  809,  809, 1207,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  655,  655,  655,  655,
      655,  655,  655,  655,  655,  655,  742,  742,  742,  742,
      828,  828,  858,  828,  878,  858,  870,  769,  786,  870,
      882,  769,  786,  754,  754,  769,  786,  829,  829,  885,
      829,  769,  786,  742, 1181,  886,  742,  769,  786,  830,
      830,  872,  830, 1473,  872,  878,  742,  764,  769,  786,

     1469,  882,  769,  786,  764,  764,  769,  786,  764,  764,
      885,  764,  769,  786,  742,  764,  886,  742,  769,  786,
     1187,  831,  831,  764,  831, 1187,  888,  742,  763,  763,
      763,  763,  781,  763,  873,  764, 1468,  873,  874,  781,
      781,  874,  875,  781,  781,  875,  781, 1467,  834,  834,
      781,  834, 1183,  835,  835,  763,  835,  888,  781,  769,
      786,  876,  763,  763,  876,  880,  763,  763,  880,  763,
      781,  837,  837,  763,  837,  840,  840,  906,  840,  860,
      860,  763,  860,  861,  861,  908,  861,  938,  938,  764,
      764,  764,  764,  763,  764, 1181,  764,  764,  862,  862,

     1466,  862,  863,  863, 1230,  863,  864,  864,  906,  864,
      865,  865,  909,  865,  866,  866,  908,  866,  867,  867,
      922,  867,  925, 1231,  781,  781,  781,  781,  927,  781,
      928,  781,  781,  879,  879,  879,  879,  929,  930,  946,
      949,  932,  951,  909,  952,  932,  953,  763,  763,  763,
      763,  922,  763,  925,  763,  763,  846,  932, 1453,  927,
     1183,  928,  932,  962,  962, 1000, 1000, 1241,  929,  930,
      946,  949, 1210,  951, 1230,  952,  989,  953, 1235,  989,
     1231,  846,  846,  846,  846,  846,  846,  846,  846,  846,
      846,  846,  846,  846,  846,  846,  846,  846,  846,  846,

      846,  846,  846,  846,  846,  846,  846,  847,  847,  847,
      847,  847,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  887,  887,  887,  887,  954,  847,  847,
      847,  847,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  847,  847,  847,  847,  847,  847,  847,
      847,  847,  847,  847,  992, 1210,  924,  926,  954,  994,
      948, 1236,  887,  905,  971,  971, 1241,  971, 1171,  926,
      905,  905,  910,  995,  905,  905,  910,  905,  926,  924,
      910,  905,  926,  948, 1235,  992,  910,  924,  926,  905,

      994,  948,  910,  887,  904,  904,  904,  904,  956,  904,
      926,  905,  956,  910,  995,  973,  973,  910,  973,  926,
     1171,  910, 1223,  926,  956,  981,  981,  910,  981,  956,
     1452,  904, 1228,  910,  984,  984, 1208,  984,  904,  904,
     1233,  990,  904,  904,  990,  904,  996, 1451,  993,  904,
      931,  993,  986,  986,  924,  986, 1228,  904,  948, 1450,
      987,  987,  931,  987, 1223,  905,  905,  905,  905,  904,
      905,  931,  905,  905,  910,  931, 1236,  996,  936, 1443,
      936,  931,  936,  936,  936,  936,  936,  936,  936,  936,
      936, 1003, 1003,  931,  998,  998,  998,  998, 1015, 1028,

     1028, 1149,  931,  960, 1017,  960,  931,  960,  960,  960,
      960,  960,  960,  960,  960,  960, 1018, 1041, 1047, 1047,
     1208, 1041, 1149,  904,  904,  904,  904, 1242,  904, 1015,
      904,  904,  935, 1041, 1180, 1017, 1122, 1122, 1041, 1122,
      935,  935,  935,  935, 1442, 1031, 1233, 1018,  935,  935,
      935,  935,  935,  935,  935,  935,  935,  935,  935,  935,
      935,  935,  935,  935,  935,  935,  935,  935,  935,  935,
      935,  935,  935,  935,  950,  955, 1031, 1019, 1034, 1036,
     1033, 1019, 1037, 1038, 1039, 1019,  950,  955, 1055, 1056,
     1057, 1019, 1056, 1060, 1056,  950,  955, 1019, 1061,  950,

      955, 1084, 1200, 1033, 1084,  950,  955, 1063, 1019, 1034,
     1036, 1033, 1019, 1037, 1038, 1039, 1019,  950,  955, 1055,
     1180, 1057, 1019, 1200, 1060, 1242,  950,  955, 1019, 1061,
      950,  955, 1013, 1013, 1013, 1013, 1014, 1013, 1063, 1064,
     1441, 1232, 1056, 1014, 1014, 1440, 1212, 1014, 1014, 1065,
     1014, 1035, 1062, 1064, 1014, 1066, 1062, 1067, 1066, 1013,
     1066, 1069, 1014, 1035, 1070, 1062, 1013, 1013, 1033, 1019,
     1013, 1013, 1035, 1013, 1014, 1088, 1035, 1013, 1090, 1157,
     1065, 1264, 1035, 1062, 1064, 1013, 1430, 1062, 1067, 1040,
     1093, 1094, 1069, 1096, 1035, 1070, 1062, 1013, 1427, 1097,

     1264, 1040, 1424, 1035, 1423, 1206, 1088, 1035, 1066, 1090,
     1040, 1098, 1089, 1097, 1040, 1089, 1100, 1089, 1102, 1103,
     1040, 1093, 1094, 1410, 1096, 1084, 1084, 1232, 1014, 1014,
     1014, 1014, 1040, 1014, 1409, 1014, 1014, 1117, 1206, 1408,
     1117, 1040, 1098, 1126, 1097, 1040, 1151, 1100, 1407, 1102,
     1103, 1013, 1013, 1013, 1013, 1176, 1013, 1175, 1013, 1013,
     1044, 1123, 1123, 1212, 1123, 1089, 1157, 1157, 1044, 1044,
     1044, 1044, 1124, 1124, 1126, 1124, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,
     1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044, 1044,

     1044, 1044, 1045, 1151, 1045, 1146, 1045, 1045, 1045, 1045,
     1045, 1045, 1045, 1045, 1045, 1068, 1151, 1175, 1068, 1099,
     1068, 1074, 1099, 1095, 1099, 1243, 1401, 1095, 1074, 1074,
     1246, 1245, 1074, 1074, 1245, 1074, 1095, 1273, 1146, 1074,
     1273, 1213, 1068, 1246, 1213, 1068, 1213, 1074, 1128, 1128,
     1128, 1128, 1240, 1400, 1095, 1068, 1243, 1155, 1095, 1074,
     1399, 1117, 1117, 1129, 1129, 1129, 1129, 1095, 1068, 1146,
     1389, 1175, 1099, 1068, 1176, 1176, 1068, 1075, 1075, 1075,
     1075, 1075, 1075, 1075, 1075, 1075, 1068, 1073, 1073, 1073,
     1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073,

     1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073, 1073,
     1073, 1073, 1073, 1074, 1074, 1074, 1074, 1076, 1074, 1388,
     1074, 1074, 1163, 1387, 1076, 1076, 1107, 1101, 1076, 1076,
     1101, 1076, 1101, 1107, 1107, 1076, 1218, 1107, 1107, 1218,
     1107, 1218, 1386, 1076, 1107, 1134, 1134, 1134, 1134, 1155,
     1238, 1155, 1107, 1160, 1101, 1076, 1163, 1101, 1135, 1135,
     1135, 1135, 1240, 1165, 1107, 1213, 1213, 1101, 1108, 1108,
     1108, 1108, 1108, 1108, 1108, 1108, 1108, 1144, 1170, 1147,
     1101, 1136, 1136, 1136, 1136, 1101, 1220, 1163, 1101, 1109,
     1138, 1138, 1138, 1138, 1385, 1186, 1109, 1109, 1101, 1160,

     1109, 1109, 1144, 1109, 1147, 1165, 1384, 1109, 1166, 1076,
     1076, 1076, 1076, 1162, 1076, 1109, 1076, 1076, 1107, 1107,
     1107, 1107, 1239, 1107, 1184, 1107, 1107, 1109, 1189, 1186,
     1160, 1381, 1167, 1144, 1238, 1147, 1165, 1143, 1162, 1263,
     1263, 1166, 1168, 1220, 1378, 1185, 1265, 1265, 1185, 1184,
     1185, 1376, 1195, 1238, 1190, 1195, 1220, 1195, 1170, 1143,
     1186, 1162, 1170, 1189, 1237, 1167, 1143, 1143, 1194, 1162,
     1143, 1143, 1166, 1143, 1170, 1168, 1192, 1143, 1148, 1170,
     1184, 1109, 1109, 1109, 1109, 1143, 1109, 1190, 1109, 1109,
     1142, 1142, 1142, 1142, 1189, 1142, 1167, 1143, 1185, 1148,

     1362, 1247, 1361, 1148, 1358, 1195, 1168, 1148, 1304, 1250,
     1192, 1194, 1191, 1148, 1198, 1164, 1357, 1142, 1190, 1148,
     1196, 1239, 1239, 1304, 1142, 1142, 1162, 1225, 1142, 1142,
     1148, 1142, 1247, 1191, 1148, 1142, 1164, 1191, 1148, 1198,
     1250, 1192, 1194, 1142, 1148, 1356, 1191, 1193, 1164, 1196,
     1148, 1143, 1143, 1143, 1143, 1142, 1143, 1164, 1143, 1143,
     1217, 1164, 1199, 1353, 1191, 1225, 1219, 1164, 1191, 1219,
     1198, 1219, 1221, 1169, 1352, 1292, 1193, 1191, 1292, 1164,
     1196, 1351, 1251, 1237, 1237, 1174, 1350, 1253, 1164, 1217,
     1193, 1148, 1164, 1174, 1169, 1174, 1225, 1174, 1174, 1174,

     1174, 1174, 1174, 1174, 1174, 1174, 1169, 1221, 1199, 1142,
     1142, 1142, 1142, 1251, 1142, 1169, 1142, 1142, 1253, 1169,
     1217, 1193, 1347, 1203, 1197, 1169, 1224, 1197, 1226, 1197,
     1271, 1226, 1294, 1226, 1343, 1294, 1205, 1169, 1221, 1199,
     1305, 1305, 1293, 1227, 1297, 1203, 1169, 1224, 1298, 1299,
     1169, 1197, 1203, 1203, 1197, 1342, 1203, 1203, 1205, 1203,
     1341, 1271, 1340, 1203, 1197, 1205, 1205, 1226, 1227, 1205,
     1205, 1203, 1205, 1293, 1204, 1297, 1205, 1197, 1224, 1298,
     1299, 1226, 1197, 1203, 1205, 1197, 1204, 1204, 1204, 1204,
     1204, 1204, 1204, 1204, 1204, 1197, 1205, 1229, 1226, 1227,

     1244, 1360, 1229, 1244, 1360, 1244, 1276, 1276, 1276, 1276,
     1229, 1229, 1229, 1229, 1303, 1252, 1333, 1303, 1252, 1303,
     1252, 1277, 1277, 1277, 1277, 1278, 1278, 1278, 1278, 1279,
     1279, 1279, 1279, 1280, 1280, 1280, 1280, 1203, 1203, 1203,
     1203, 1327, 1203, 1326, 1203, 1203, 1281, 1281, 1281, 1281,
     1205, 1205, 1205, 1205, 1252, 1205, 1322, 1205, 1205, 1282,
     1282, 1282, 1282, 1283, 1283, 1283, 1283, 1303, 1252, 1284,
     1284, 1284, 1284, 1285, 1285, 1285, 1285, 1308, 1308, 1291,
     1323, 1323, 1323, 1323, 1317, 1252, 1291, 1291, 1328, 1330,
     1291, 1291, 1330, 1291, 1330, 1321, 1320, 1291, 1324, 1324,

     1324, 1324, 1296, 1319, 1296, 1291, 1296, 1296, 1296, 1296,
     1296, 1296, 1296, 1296, 1296, 1317, 1301, 1291, 1301, 1328,
     1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1301, 1325,
     1325, 1325, 1325, 1331, 1331, 1331, 1331, 1331, 1331, 1331,
     1331, 1331, 1330, 1332, 1318, 1314, 1332, 1313, 1332, 1334,
     1334, 1334, 1334, 1334, 1334, 1334, 1334, 1334, 1338, 1339,
     1349, 1338, 1339, 1338, 1339, 1344, 1312, 1311, 1344, 1310,
     1344, 1291, 1291, 1291, 1291, 1335, 1291, 1309, 1291, 1291,
     1307, 1306, 1335, 1335, 1354, 1377, 1335, 1335, 1382, 1335,
     1337, 1349, 1302, 1335, 1300, 1295, 1332, 1337, 1337, 1287,

     1345, 1337, 1337, 1345, 1337, 1345, 1286, 1275, 1337, 1402,
     1274, 1338, 1339, 1335, 1272, 1354, 1377, 1269, 1344, 1382,
     1346, 1268, 1355, 1346, 1348, 1346, 1359, 1348, 1337, 1348,
     1355, 1355, 1355, 1355, 1359, 1359, 1359, 1359, 1363, 1364,
     1402, 1363, 1364, 1363, 1364, 1365, 1366, 1425, 1365, 1366,
     1365, 1366, 1367, 1345, 1267, 1367, 1368, 1367, 1266, 1368,
     1369, 1368, 1262, 1369, 1261, 1369, 1260, 1335, 1335, 1335,
     1335, 1259, 1335, 1346, 1335, 1335, 1370, 1348, 1425, 1370,
     1258, 1370, 1337, 1337, 1337, 1337, 1257, 1337, 1256, 1337,
     1337, 1363, 1364, 1379, 1379, 1379, 1379, 1371, 1365, 1366,

     1371, 1372, 1371, 1255, 1372, 1367, 1372, 1373, 1254, 1368,
     1373, 1249, 1373, 1369, 1367, 1374, 1375, 1248, 1374, 1375,
     1374, 1375, 1380, 1380, 1380, 1380, 1383, 1367, 1383, 1370,
     1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1383, 1390,
     1393, 1202, 1390, 1393, 1390, 1393, 1404, 1141, 1140, 1404,
     1371, 1404, 1406, 1139, 1372, 1406, 1426, 1406, 1396, 1371,
     1373, 1396, 1137, 1396, 1426, 1426, 1426, 1426, 1374, 1375,
     1412, 1414, 1371, 1412, 1414, 1412, 1414, 1416, 1375, 1133,
     1416, 1132, 1416, 1131, 1392, 1418, 1130, 1392, 1418, 1392,
     1418, 1375, 1390, 1393, 1127, 1120, 1119, 1392, 1118, 1392,

     1116, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
     1115, 1396, 1114, 1113, 1379, 1391, 1112, 1111, 1391, 1110,
     1391, 1105, 1104, 1412, 1414, 1391, 1091, 1087, 1086, 1085,
     1416, 1083, 1082, 1391, 1391, 1391, 1391, 1392, 1418, 1081,
     1080, 1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391,
     1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391, 1391,
     1391, 1391, 1391, 1391, 1391, 1391, 1391, 1079, 1391, 1394,
     1420, 1078, 1394, 1420, 1394, 1420, 1077, 1422, 1428, 1394,
     1422, 1428, 1422, 1428, 1072, 1071, 1058, 1394, 1394, 1394,
     1394, 1054, 1053, 1052, 1051, 1394, 1394, 1394, 1394, 1394,

     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
     1394, 1395, 1394, 1420, 1395, 1050, 1395, 1049, 1048, 1043,
     1422, 1428, 1042, 1032, 1395, 1030, 1395, 1029, 1395, 1395,
     1395, 1395, 1395, 1395, 1395, 1395, 1395, 1398, 1431, 1027,
     1398, 1025, 1398, 1024, 1023, 1021, 1431, 1431, 1431, 1431,
     1398, 1020, 1398, 1016, 1398, 1398, 1398, 1398, 1398, 1398,
     1398, 1398, 1398, 1434, 1395, 1397, 1010, 1009, 1397, 1008,
     1397, 1434, 1434, 1434, 1434, 1397, 1429, 1432, 1007, 1429,
     1432, 1429, 1432, 1397, 1397, 1397, 1397, 1006, 1005, 1428,

     1398, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
     1397, 1397, 1397, 1397, 1397, 1397, 1397, 1004, 1397, 1403,
     1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1411, 1429,
     1432, 1411, 1437, 1411, 1002, 1001, 1470,  997,  988, 1432,
     1437, 1437, 1437, 1437, 1470, 1470, 1470, 1470,  985,  983,
      982,  969, 1432,  968, 1411, 1411, 1411, 1411, 1411, 1411,
     1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411,
     1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411, 1411,
     1413, 1411,  967, 1413,  966, 1413,  965,  964, 1455, 1417,

      963, 1455, 1417, 1455, 1417,  959,  958, 1413, 1413, 1413,
     1413, 1413, 1413, 1413, 1413, 1413, 1417, 1417, 1417, 1417,
     1417, 1417, 1417, 1417, 1417, 1471,  957,  947,  945, 1472,
      944,  943,  942, 1471, 1471, 1471, 1471, 1472, 1472, 1472,
     1472,  941,  940, 1413, 1415,  939,  934, 1415,  933, 1415,
      923, 1455, 1417, 1457,  921,  920, 1457, 1459, 1457,  918,
     1459, 1461, 1459,  916, 1461,  915, 1461,  914,  912,  911,
     1415, 1415, 1415, 1415, 1415, 1415, 1415, 1415, 1415, 1415,
     1415, 1415, 1415, 1415, 1415, 1415, 1415, 1415, 1415, 1415,
     1415, 1415, 1415, 1415, 1415, 1415,  907, 1415, 1419,  901,

      900, 1419,  899, 1419, 1433,  898, 1457, 1433,  894, 1433,
     1459,  893,  892,  891, 1461,  890,  889,  884,  883,  881,
      868,  842,  841,  839, 1419, 1419, 1419, 1419, 1419, 1419,
     1419, 1419, 1419, 1419, 1419, 1419, 1419, 1419, 1419, 1419,
     1419, 1419, 1419, 1419, 1419, 1419, 1419, 1419, 1419, 1419,
     1421, 1419,  838, 1421,  814, 1421, 1435, 1433,  797, 1435,
     1436, 1435,  796, 1436,  794, 1436, 1433, 1421, 1421, 1421,
     1421, 1421, 1421, 1421, 1421, 1421,  792, 1438,  791, 1433,
     1438, 1439, 1438,  790, 1439, 1463, 1439,  788, 1463,  787,
     1463, 1465,  783,  780, 1465,  779, 1465,  777,  775,  774,

      773,  771,  770, 1421,  766,  758,  757,  756,  755, 1435,
      753,  752,  751, 1436,  750,  749,  748,  747, 1435,  746,
      745,  732, 1436,  721,  719,  717,  705,  704,  690,  686,
     1438, 1435,  659,  656, 1439, 1436,  654,  653, 1463, 1438,
      651,  644, 1444, 1439, 1465, 1444,  643, 1444,  642,  641,
      640,  639, 1438,  637,  635, 1444, 1439, 1444,  602, 1444,
     1444, 1444, 1444, 1444, 1444, 1444, 1444, 1444,  587,  586,
      583,  582,  581,  580,  578,  577,  576,  575,  574,  573,
      572,  571,  568,  567,  557,  554,  548,  544,  541,  540,
      539,  533,  531,  530,  522, 1444, 1445,  519,  509,  508,

      507,  504,  503,  502, 1445, 1445, 1445, 1445,  492,  491,
      456,  455, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445,
     1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445,
     1445, 1445, 1445, 1445, 1445, 1445, 1445, 1445, 1446,  451,
      449, 1446,  447, 1446,  446,  442,  424,  414,  413,  412,
      410, 1446,  409, 1446,  397, 1446, 1446, 1446, 1446, 1446,
     1446, 1446, 1446, 1446,  395,  394,  393,  392,  391,  390,
      388,  387,  386,  385,  383,  382,  381,  379,  377,  376,
      375,  374,  373,  369,  367,  364,  359,  358,  356,  349,
      348, 1446, 1447,  347,  346,  345,  344,  330,  329,  327,

     1447, 1447, 1447, 1447,  326,  323,  322,  320, 1447, 1447,
     1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447,
     1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447, 1447,
     1447, 1447, 1447, 1447, 1448,  319,  317, 1448,  314, 1448,
      312,  298,  297,  289,  288,  287,  286, 1448,  285, 1448,
      283, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448, 1448,
      278,  274,  271,  268,  267,  264,  259,  257,  255,  245,
      237,  235,  232,  228,  226,  221,  218,  216,  215,  214,
      213,  211,  209,  203,  199,  198,  196, 1448, 1449,  193,
      182,  181,  180,  176,  175,  174, 1449, 1449, 1449, 1449,

      161,  153,  146,  145, 1449, 1449, 1449, 1449, 1449, 1449,
     1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449,
     1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449, 1449,
     1454,  143,  140, 1454,  125, 1454,  124,  120,  119,  118,
      112,  105,  102,  100,   96,   95,   93, 1454, 1454, 1454,
     1454, 1454, 1454, 1454, 1454, 1454,   92, 1458,   89,   88,
     1458,   85, 1458,   81,   78,   75,   72,   71,   70,   69,
       65,   62,   58,   57, 1458, 1458, 1458, 1458, 1458, 1458,
     1458, 1458, 1458, 1454, 1456, 1456, 1456, 1456, 1456, 1456,
     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,

     1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456, 1456,
     1458, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460, 1460,
     1460, 1460, 1460, 1460, 1460, 1460, 1460, 1462,   54,   49,
     1462,   47, 1462,   46,   41,   37,   36,   35,   18,   17,
        0,    0,    0,    0, 1462, 1462, 1462, 1462, 1462, 1462,
     1462, 1462, 1462,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
     1462, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,

     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464, 1464,
     1464, 1464, 1464, 1464, 1464, 1464, 1464, 1494, 1494, 1494,
     1494, 1494, 1494, 1494, 1494, 1494, 1494, 1494, 1495, 1495,
     1495, 1495, 1495, 1495, 1495, 1495, 1495, 1495, 1495, 1496,
     1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496, 1496,
     1497, 1497, 1497, 1497, 1497, 1497, 1497, 1497, 1497, 1497,
     1497, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498, 1498,
     1498, 1498, 1499, 1499, 1499, 1499, 1499, 1499, 1499, 1499,
     1499, 1499, 1499, 1500, 1500, 1500, 1500, 1500, 1500, 1500,
     1500, 1500, 1500, 1500, 1501, 1501, 1501, 1501, 1501, 1501,

     1501, 1501, 1501, 1501, 1501, 1502, 1502, 1502, 1502, 1502,
     1502, 1502, 1502, 1502, 1502, 1502, 1503, 1503, 1503, 1503,
     1503, 1503, 1503, 1503, 1503, 1503, 1503, 1504, 1504, 1504,
     1504, 1504, 1504, 1504, 1504, 1504, 1504, 1504, 1505, 1505,
     1505, 1505, 1506, 1506,    0, 1506, 1506, 1506, 1506, 1506,
     1506, 1506, 1506, 1507,    0,    0,    0, 1507, 1507, 1507,
     1507, 1507, 1507, 1507, 1508, 1508,    0,    0, 1508, 1508,
     1508, 1508, 1508, 1508, 1508, 1509, 1509,    0, 1509, 1509,
     1509, 1509, 1509, 1509, 1509, 1509, 1510,    0,    0,    0,
     1510, 1510, 1510, 1510, 1510, 1510, 1510, 1511,    0,    0,

        0, 1511, 1511, 1511, 1511, 1511, 1511, 1511, 1512,    0,
        0,    0, 1512, 1512, 1512, 1512, 1512, 1512, 1512, 1513,
     1513,    0, 1513, 1513, 1513, 1513, 1513, 1513, 1513, 1513,
     1514, 1514,    0, 1514, 1514, 1514, 1514, 1514, 1514, 1514,
     1514, 1515, 1515,    0, 1515, 1515, 1515, 1515, 1515, 1515,
     1515, 1515, 1516, 1516,    0, 1516, 1516, 1516, 1516, 1516,
     1516, 1516, 1516, 1517, 1517, 1517, 1517, 1517, 1517, 1517,
     1517, 1517, 1517, 1517, 1518, 1518, 1518, 1518, 1519, 1519,
        0, 1519, 1519, 1519, 1519, 1519, 1519, 1519, 1519, 1520,
     1520,    0, 1520, 1520, 1520, 1520, 1520, 1520, 1520, 1520,

     1521, 1521,    0, 1521, 1521, 1521, 1521, 1521, 1521, 1521,
     1521, 1522, 1522,    0, 1522, 1522, 1522, 1522, 1522, 1522,
     1522, 1522, 1523,    0, 1523, 1523, 1524, 1524, 1525,    0,
        0, 1525, 1525, 1526,    0,    0,    0, 1526, 1526, 1526,
     1526, 1526, 1526, 1526, 1527, 1527,    0,    0, 1527, 1527,
     1527, 1527, 1527, 1527, 1527, 1528, 1528,    0, 1528, 1528,
     1528, 1528, 1528, 1528, 1528, 1528, 1529,    0,    0,    0,
     1529, 1529, 1529, 1529, 1529, 1529, 1529, 1530,    0,    0,
        0, 1530, 1530, 1530, 1530, 1530, 1530, 1530, 1531,    0,
        0,    0, 1531, 1531, 1531, 1531, 1531, 1531, 1531, 1532,

     1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532, 1532,
     1533, 1533,    0, 1533, 1533, 1533, 1533, 1533, 1533, 1533,
     1533, 1534, 1534,    0, 1534, 1534, 1534, 1534, 1534, 1534,
     1534, 1534, 1535, 1535,    0, 1535, 1535, 1535, 1535, 1535,
     1535, 1535, 1535, 1536, 1536,    0, 1536, 1536, 1536, 1536,
     1536, 1536, 1536, 1536, 1537, 1537,    0, 1537, 1537, 1537,
     1537, 1537, 1537, 1537, 1537, 1538, 1538, 1538, 1538, 1538,
     1538, 1538, 1538, 1538, 1538, 1538, 1540, 1540,    0, 1540,
     1540, 1540, 1540, 1540, 1540, 1540, 1540, 1541, 1541,    0,
     1541, 1541, 1541, 1541, 1541, 1541, 1541, 1541, 1542, 1542,

        0, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1542, 1543,
     1543,    0, 1543, 1543, 1543, 1543, 1543, 1543, 1543, 1543,
     1544, 1544,    0, 1544, 1544, 1544, 1544, 1544, 1544, 1544,
     1544, 1545, 1545,    0, 1545, 1545, 1545, 1545, 1545, 1545,
     1545, 1545, 1546, 1546, 1546, 1546, 1546,    0, 1546, 1546,
     1546, 1546, 1546, 1547, 1547,    0, 1547, 1547, 1547, 1547,
     1547, 1547, 1547, 1547, 1549, 1549, 1550, 1550, 1550, 1550,
        0, 1550, 1550, 1550, 1550, 1550, 1550, 1551, 1551, 1551,
     1551, 1551,    0, 1551, 1551, 1551, 1551, 1551, 1552, 1552,
        0, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1552, 1553,

     1553, 1553, 1553, 1553, 1553, 1553, 1553, 1553, 1553, 1553,
     1554, 1554,    0, 1554, 1554, 1554, 1554, 1554, 1554, 1554,
     1554, 1555, 1555,    0, 1555, 1555, 1555, 1555, 1555, 1555,
     1555, 1555, 1556, 1556,    0, 1556, 1556, 1556, 1556, 1556,
     1556, 1556, 1556, 1557, 1557,    0, 1557, 1557, 1557, 1557,
     1557, 1557, 1557, 1557, 1558, 1558,    0, 1558, 1558, 1558,
     1558, 1558, 1558, 1558, 1558, 1559, 1559,    0, 1559, 1559,
     1559, 1559, 1559, 1559, 1559, 1559, 1560, 1560,    0, 1560,
     1560, 1560, 1560, 1560, 1560, 1560, 1560, 1561, 1561,    0,
     1561, 1561, 1561, 1561, 1561, 1561, 1561, 1561, 1562, 1562,

        0, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1562, 1563,
     1563,    0, 1563, 1563, 1563, 1563, 1563, 1563, 1563, 1563,
     1564, 1564,    0, 1564, 1564, 1564, 1564, 1564, 1564, 1564,
     1564, 1565, 1565,    0, 1565, 1565, 1565, 1565, 1565, 1565,
     1565, 1565, 1566, 1566,    0, 1566, 1566, 1566, 1566, 1566,
     1566, 1566, 1566, 1567, 1567,    0, 1567, 1567, 1567, 1567,
     1567, 1567, 1567, 1567, 1568, 1568,    0, 1568, 1568, 1568,
     1568, 1568, 1568, 1568, 1568, 1569, 1569, 1569, 1569, 1569,
     1569, 1569, 1569, 1569, 1569, 1569, 1571, 1571, 1572, 1572,
     1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1572, 1573,

     1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573, 1573,
     1574, 1574,    0, 1574, 1574, 1574, 1574, 1574, 1574, 1574,
     1574, 1575, 1575,    0, 1575, 1575, 1575, 1575, 1575, 1575,
     1575, 1575, 1576, 1576,    0, 1576, 1576, 1576, 1576, 1576,
     1576, 1576, 1576, 1577, 1577,    0, 1577, 1577, 1577, 1577,
     1577, 1577, 1577, 1577, 1578, 1578,    0, 1578, 1578, 1578,
     1578, 1578, 1578, 1578, 1578, 1579, 1579,    0, 1579, 1579,
     1579, 1579, 1579, 1579, 1579, 1579, 1580, 1580,    0, 1580,
     1580, 1580, 1580, 1580, 1580, 1580, 1580, 1581, 1581,    0,
     1581, 1581, 1581, 1581, 1581, 1581, 1581, 1581, 1582, 1582,

        0, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1582, 1583,
     1583,    0, 1583, 1583, 1583, 1583, 1583, 1583, 1583, 1583,
     1584, 1584,    0, 1584, 1584, 1584, 1584, 1584, 1584, 1584,
     1584, 1585, 1585,    0, 1585, 1585, 1585, 1585, 1585, 1585,
     1585, 1585, 1586, 1586,    0, 1586, 1586, 1586, 1586, 1586,
     1586, 1586, 1586, 1587, 1587,    0, 1587, 1587, 1587, 1587,
     1587, 1587, 1587, 1587, 1588, 1588,    0, 1588, 1588, 1588,
     1588, 1588, 1588, 1588, 1588, 1589, 1589,    0, 1589, 1589,
     1589, 1589, 1589, 1589, 1589, 1589, 1590, 1590,    0, 1590,
     1590, 1590, 1590, 1590, 1590, 1590, 1590, 1591, 1591,    0,

     1591, 1591, 1591, 1591, 1591, 1591, 1591, 1591, 1592, 1592,
        0, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1592, 1593,
     1593,    0, 1593, 1593, 1593, 1593, 1593, 1593, 1593, 1593,
     1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594, 1594,
     1594, 1595, 1595, 1595, 1595, 1595, 1595, 1595, 1595, 1595,
     1595, 1595, 1596, 1596, 1596, 1596, 1596, 1596, 1596, 1596,
     1596, 1596, 1596, 1597, 1597,    0, 1597, 1597, 1597, 1597,
     1597, 1597, 1597, 1597, 1598, 1598,    0, 1598, 1598, 1598,
     1598, 1598, 1598, 1598, 1598, 1599, 1599,    0, 1599, 1599,
     1599, 1599, 1599, 1599, 1599, 1599, 1600, 1600,    0, 1600,

     1600, 1600, 1600, 1600, 1600, 1600, 1600, 1601, 1601,    0,
     1601, 1601, 1601, 1601, 1601, 1601, 1601, 1601, 1602, 1602,
        0, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1602, 1603,
     1603,    0, 1603, 1603, 1603, 1603, 1603, 1603, 1603, 1603,
     1604, 1604,    0, 1604, 1604, 1604, 1604, 1604, 1604, 1604,
     1604, 1605, 1605,    0, 1605, 1605, 1605, 1605, 1605, 1605,
     1605, 1605, 1606,    0, 1606, 1606, 1606, 1606, 1606, 1606,
     1606, 1606, 1606, 1607, 1607,    0, 1607, 1607, 1607, 1607,
     1607, 1607, 1607, 1607, 1608, 1608, 1608, 1608, 1608, 1608,
     1608, 1608, 1608, 1608, 1608, 1609, 1609,    0, 1609, 1609,

     1609, 1609, 1609, 1609, 1609, 1609, 1610, 1610,    0, 1610,
     1610, 1610, 1610, 1610, 1610, 1610, 1610, 1611, 1611,    0,
     1611, 1611, 1611, 1611, 1611, 1611, 1611, 1611, 1612, 1612,
        0, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1612, 1613,
     1613,    0, 1613, 1613, 1613, 1613, 1613, 1613, 1613, 1613,
     1614, 1614,    0, 1614, 1614, 1614, 1614, 1614, 1614, 1614,
     1614, 1615, 1615,    0, 1615, 1615, 1615, 1615, 1615, 1615,
     1615, 1615, 1616, 1616,    0, 1616, 1616, 1616, 1616, 1616,
     1616, 1616, 1616, 1617, 1617,    0, 1617, 1617, 1617, 1617,
     1617, 1617, 1617, 1617, 1618, 1618,    0, 1618, 1618, 1618,

     1618, 1618, 1618, 1618, 1618, 1619, 1619,    0, 1619, 1619,
     1619, 1619, 1619, 1619, 1619, 1619, 1620, 1620,    0, 1620,
     1620, 1620, 1620, 1620, 1620, 1620, 1620, 1621, 1621,    0,
     1621, 1621, 1621, 1621, 1621, 1621, 1621, 1621, 1622, 1622,
        0, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1622, 1623,
     1623,    0, 1623, 1623, 1623, 1623, 1623, 1623, 1623, 1623,
     1624, 1624,    0, 1624, 1624, 1624, 1624, 1624, 1624, 1624,
     1624, 1625, 1625,    0, 1625, 1625, 1625, 1625, 1625, 1625,
     1625, 1625, 1626, 1626,    0, 1626, 1626, 1626, 1626, 1626,
     1626, 1626, 1626, 1627, 1627,    0, 1627, 1627, 1627, 1627,

     1627, 1627, 1627, 1627, 1628, 1628,    0, 1628, 1628, 1628,
     1628, 1628, 1628, 1628, 1628, 1629, 1629,    0, 1629, 1629,
     1629, 1629, 1629, 1629, 1629, 1629, 1630, 1630,    0, 1630,
     1630, 1630, 1630, 1630, 1630, 1630, 1630, 1631, 1631,    0,
     1631, 1631, 1631, 1631, 1631, 1631, 1631, 1631, 1632, 1632,
     1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1632, 1633,
     1633, 1633, 1633, 1633, 1633, 1633, 1633, 1633, 1633, 1633,
     1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634, 1634,
     1634, 1635, 1635,    0, 1635, 1635, 1635, 1635, 1635, 1635,
     1635, 1635, 1636, 1636,    0, 1636, 1636, 1636, 1636, 1636,

     1636, 1636, 1636, 1637, 1637,    0, 1637, 1637, 1637, 1637,
     1637, 1637, 1637, 1637, 1638, 1638,    0, 1638, 1638, 1638,
     1638, 1638, 1638, 1638, 1638, 1639, 1639,    0, 1639, 1639,
     1639, 1639, 1639, 1639, 1639, 1639, 1640, 1640,    0, 1640,
     1640, 1640, 1640, 1640, 1640, 1640, 1640, 1641, 1641,    0,
     1641, 1641, 1641, 1641, 1641, 1641, 1641, 1641, 1642,    0,
     1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1642, 1643,
     1643,    0, 1643, 1643, 1643, 1643, 1643, 1643, 1643, 1643,
     1644, 1644,    0, 1644, 1644, 1644, 1644, 1644, 1644, 1644,
     1644, 1645, 1645,    0, 1645, 1645, 1645, 1645, 1645, 1645,

     1645, 1645, 1646,    0, 1646, 1646, 1647, 1647,    0, 1647,
     1647, 1647, 1647, 1647, 1647, 1647, 1647, 1648, 1648,    0,
     1648, 1648, 1648, 1648, 1648, 1648, 1648, 1648, 1649, 1649,
        0, 1649, 1649, 1649, 1649, 1649, 1649, 1649, 1649, 1650,
     1650,    0, 1650, 1650, 1650, 1650, 1650, 1650, 1650, 1650,
     1651, 1651,    0, 1651, 1651, 1651, 1651, 1651, 1651, 1651,
     1651, 1652, 1652,    0, 1652, 1652, 1652, 1652, 1652, 1652,
     1652, 1652, 1653, 1653,    0, 1653, 1653, 1653, 1653, 1653,
     1653, 1653, 1653, 1654, 1654,    0, 1654, 1654, 1654, 1654,
     1654, 1654, 1654, 1654, 1655, 1655, 1655, 1655, 1655, 1655,

     1655, 1655, 1655, 1655, 1655, 1656, 1656,    0, 1656, 1656,
     1656, 1656, 1656, 1656, 1656, 1656, 1657, 1657,    0, 1657,
     1657, 1657, 1657, 1657, 1657, 1657, 1657, 1658, 1658,    0,
     1658, 1658, 1658, 1658, 1658, 1658, 1658, 1658, 1660, 1660,
        0, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1660, 1661,
     1661,    0, 1661, 1661, 1661, 1661, 1661, 1661, 1661, 1661,
     1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662, 1662,
     1662, 1663, 1663, 1663, 1663, 1663, 1663, 1663, 1663, 1663,
     1663, 1663, 1664, 1664, 1664, 1664, 1664, 1664, 1664, 1664,
     1664, 1664, 1664, 1665, 1665,    0, 1665, 1665, 1665, 1665,

     1665, 1665, 1665, 1665, 1666,    0, 1666,    0, 1666, 1666,
     1667, 1667,    0, 1667, 1667, 1667, 1667, 1667, 1667, 1667,
     1667, 1668,    0, 1668, 1668, 1669,    0, 1669, 1669, 1672,
     1672,    0, 1672, 1672, 1672, 1672, 1672, 1672, 1672, 1672,
     1673, 1673,    0, 1673, 1673, 1673, 1673, 1673, 1673, 1673,
     1673, 1674, 1674,    0, 1674, 1674, 1674, 1674, 1674, 1674,
     1674, 1674, 1675,    0, 1675, 1675, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,

     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493, 1493,
     1493, 1493, 1493, 1493, 1493, 1493

    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexgrog.l"

#line 19 "lexgrog.l"

/*
 * lexgrog.l: extract 'whatis' info from nroff man / formatted cat pages.
 *  
 * Copyright (C) 1994, 1995 Graeme W. Wilford. (Wilf.)
 * Copyright (C) 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
 *               2011, 2012 Colin Watson.
 *
 * This file is part of man-db.
 *
 * man-db is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * man-db is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with man-db; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Wed Oct 12 18:46:11 BST 1994  Wilf. (G.Wilford@ee.surrey.ac.uk) 
 * 
 * CJW: Detect grap and vgrind. Understand fill requests. Other improvements
 * in the syntax accepted.
 */

#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "gettext.h"
#define _(String) gettext (String)

#include "error.h"
#include "pipeline.h"
#include "decompress.h"
#include "security.h"
#include "encodings.h"
#include "sandbox.h"

#include "manconv_client.h"

#define YY_READ_BUF_SIZE	1024
#define MAX_NAME		8192

#define ARRAY_SIZE(array) (sizeof (array) / sizeof ((array)[0]))

extern man_sandbox *sandbox;

struct macro {
	const char *name;
	const char *value;
};

static const struct macro glyphs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from groff_char(7), although I have omitted some that are
	 * particularly unlikely to be used in NAME sections.
	 */
	{ "'A", "Á" },
	{ "'C", "Ć" },
	{ "'E", "É" },
	{ "'I", "Í" },
	{ "'O", "Ó" },
	{ "'U", "Ú" },
	{ "'Y", "Ý" },
	{ "'a", "á" },
	{ "'c", "ć" },
	{ "'e", "é" },
	{ "'i", "í" },
	{ "'o", "ó" },
	{ "'u", "ú" },
	{ "'y", "ý" },
	{ ",C", "Ç" },
	{ ",c", "ç" },
	{ "-D", "Ð" },
	{ ".i", "ı" },
	{ "/L", "Ł" },
	{ "/O", "Ø" },
	{ "/l", "ł" },
	{ "/o", "ø" },
	{ ":A", "Ä" },
	{ ":E", "Ë" },
	{ ":I", "Ï" },
	{ ":O", "Ö" },
	{ ":U", "Ü" },
	{ ":Y", "Ÿ" },
	{ ":a", "ä" },
	{ ":e", "ë" },
	{ ":i", "ï" },
	{ ":o", "ö" },
	{ ":u", "ü" },
	{ ":y", "ÿ" },
	{ "AE", "Æ" },
	{ "Bq", "„" },
	{ "Fc", "»" },
	{ "Fi", "ffi" },
	{ "Fl", "ffl" },
	{ "Fo", "«" },
	{ "IJ", "Ĳ" },
	{ "OE", "Œ" },
	{ "Sd", "ð" },
	{ "TP", "Þ" },
	{ "Tp", "þ" },
	{ "^A", "Â" },
	{ "^E", "Ê" },
	{ "^I", "Î" },
	{ "^O", "Ô" },
	{ "^U", "Û" },
	{ "^a", "â" },
	{ "^e", "ê" },
	{ "^i", "î" },
	{ "^o", "ô" },
	{ "^u", "û" },
	{ "`A", "À" },
	{ "`E", "È" },
	{ "`I", "Ì" },
	{ "`O", "Ò" },
	{ "`U", "Ù" },
	{ "`a", "à" },
	{ "`e", "è" },
	{ "`i", "ì" },
	{ "`o", "ò" },
	{ "`u", "ù" },
	{ "a\"", "˝" },
	{ "a-", "¯" },
	{ "a.", "˙" },
	{ "a^", "^" },
	{ "aa", "´" },
	{ "ab", "˘" },
	{ "ac", "¸" },
	{ "ad", "¨" },
	{ "ae", "æ" },
	{ "ah", "ˇ" },
	{ "ao", "˚" },
	{ "aq", "'" },
	{ "a~", "~" },
	{ "bq", "‚" },
	{ "cq", "’" },
	{ "dq", "\"" },
	{ "em", "—" },
	{ "en", "–" },
	{ "fc", "›" },
	{ "ff", "ff" },
	{ "fi", "fi" },
	{ "fl", "fl" },
	{ "fo", "‹" },
	{ "ga", "`" },
	{ "ha", "^" },
	{ "ho", "˛" },
	{ "hy", "‐" },
	{ "ij", "ĳ" },
	{ "lq", "“" },
	{ "oA", "Å" },
	{ "oa", "å" },
	{ "oe", "œ" },
	{ "oq", "‘" },
	{ "r!", "¡" },
	{ "r?", "¿" },
	{ "rq", "”" },
	{ "ss", "ß" },
	{ "ti", "~" },
	{ "vS", "Š" },
	{ "vZ", "Ž" },
	{ "vs", "š" },
	{ "vz", "ž" },
	{ "~A", "Ã" },
	{ "~N", "Ñ" },
	{ "~O", "Õ" },
	{ "~a", "ã" },
	{ "~n", "ñ" },
	{ "~o", "õ" }
};

static const struct macro perldocs[] = {
	/* It is vital to keep these in strcmp order (sort -t\" -k2)!  They
	 * will be searched using bsearch.
	 * Data from Pod/Man.pm.
	 */
	{ "--", "-" },
	{ "Aq", "'" },
	{ "C'", "'" },
	{ "C+", "C++" },
	{ "C`", "`" },
	{ "L\"", "\"" },
	{ "PI", "π" },
	{ "R\"", "\"" }
};

static void add_str_to_whatis (const char *string, size_t length);
static void add_char_to_whatis (unsigned char c);
static void add_separator_to_whatis (void);
static void add_wordn_to_whatis (const char *string, size_t length);
static void add_word_to_whatis (const char *string);
static void add_glyph_to_whatis (const char *string, size_t length);
static void add_perldoc_to_whatis (const char *string, size_t length);
static void mdoc_text (const char *string);
static void newline_found (void);

static char newname[MAX_NAME];
static char *p_name;
static const char *fname;
static char filters[MAX_FILTERS];

static int fill_mode;
static int waiting_for_quote;

static pipeline *decomp;

#define YY_INPUT(buf,result,max_size) { \
	size_t size = max_size; \
	const char *block = pipeline_read (decomp, &size); \
	if (block && size != 0) { \
		memcpy (buf, block, size); \
		buf[size] = '\0'; \
		result = size; \
	} else \
		result = YY_NULL; \
}
#define YY_NO_INPUT
#line 2878 "lexgrog.c"

#line 292 "lexgrog.l"
 /* Please add to this list if you know how. */
 /* Note that, since flex only supports UTF-8 by accident, character classes
  * including non-ASCII characters must be written out as (a|b|c|d) rather
  * than [abcd].
  */
 /* NOME also works for gl, pt */
 /* eptgrv : eqn, pic, tbl, grap, refer, vgrind */
#line 2888 "lexgrog.c"

#define INITIAL 0
#define MAN_PRENAME 1
#define MAN_NAME 2
#define MAN_DESC 3
#define MAN_DESC_AT 4
#define MAN_DESC_BSX 5
#define MAN_DESC_BX 6
#define MAN_DESC_BX_RELEASE 7
#define MAN_DESC_DQ 8
#define MAN_DESC_FX 9
#define MAN_DESC_NX 10
#define MAN_DESC_OX 11
#define CAT_NAME 12
#define CAT_FILE 13
#define MAN_FILE 14
#define CAT_REST 15
#define MAN_REST 16
#define FORCE_EXIT 17

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals ( void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy ( void );

int yyget_debug ( void );

void yyset_debug ( int debug_flag  );

YY_EXTRA_TYPE yyget_extra ( void );

void yyset_extra ( YY_EXTRA_TYPE user_defined  );

FILE *yyget_in ( void );

void yyset_in  ( FILE * _in_str  );

FILE *yyget_out ( void );

void yyset_out  ( FILE * _out_str  );

			int yyget_leng ( void );

char *yyget_text ( void );

int yyget_lineno ( void );

void yyset_lineno ( int _line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap ( void );
#else
extern int yywrap ( void );
#endif
#endif

#ifndef YY_NO_UNPUT
    
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy ( char *, const char *, int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen ( const char * );
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput ( void );
#else
static int input ( void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, (size_t) yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		int n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = (int) fread(buf, 1, (yy_size_t) max_size, yyin)) == 0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK /*LINTED*/break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	yy_state_type yy_current_state;
	char *yy_cp, *yy_bp;
	int yy_act;
    
	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer( yyin, YY_BUF_SIZE );
		}

		yy_load_buffer_state(  );
		}

	{
#line 340 "lexgrog.l"


 /* begin NAME section processing */
#line 3124 "lexgrog.c"

	while ( /*CONSTCOND*/1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
yy_match:
		do
			{
			YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)] ;
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 1494 )
					yy_c = yy_meta[yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
			++yy_cp;
			}
		while ( yy_current_state != 1493 );
		yy_cp = (yy_last_accepting_cpos);
		yy_current_state = (yy_last_accepting_state);

yy_find_action:
		yy_act = yy_accept[yy_current_state];

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
/* rule 1 can match eol */
YY_RULE_SETUP
#line 343 "lexgrog.l"
BEGIN (MAN_PRENAME);
	YY_BREAK
case 2:
/* rule 2 can match eol */
YY_RULE_SETUP
#line 344 "lexgrog.l"
BEGIN (CAT_NAME);
	YY_BREAK
/* general text matching */

case 3:
#line 349 "lexgrog.l"
case 4:
#line 350 "lexgrog.l"
case 5:
#line 351 "lexgrog.l"
case 6:
/* rule 6 can match eol */
YY_RULE_SETUP
#line 351 "lexgrog.l"

	YY_BREAK


case 7:
#line 356 "lexgrog.l"
case 8:
#line 357 "lexgrog.l"
case 9:
/* rule 9 can match eol */
#line 358 "lexgrog.l"
case 10:
/* rule 10 can match eol */
YY_RULE_SETUP
#line 358 "lexgrog.l"

	YY_BREAK


case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 362 "lexgrog.l"
filters[TBL_FILTER] = 't';
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 363 "lexgrog.l"
filters[EQN_FILTER] = 'e';
	YY_BREAK
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 364 "lexgrog.l"
filters[PIC_FILTER] = 'p';
	YY_BREAK
case 14:
/* rule 14 can match eol */
YY_RULE_SETUP
#line 365 "lexgrog.l"
filters[GRAP_FILTER] = 'g';
	YY_BREAK
case 15:
/* rule 15 can match eol */
#line 367 "lexgrog.l"
case 16:
/* rule 16 can match eol */
YY_RULE_SETUP
#line 367 "lexgrog.l"
filters[REF_FILTER] = 'r';
	YY_BREAK
case 17:
/* rule 17 can match eol */
YY_RULE_SETUP
#line 368 "lexgrog.l"
filters[VGRIND_FILTER] = 'v';
	YY_BREAK

case YY_STATE_EOF(MAN_REST):
#line 370 "lexgrog.l"
{	/* exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 18:
/* rule 18 can match eol */
YY_RULE_SETUP
#line 374 "lexgrog.l"

	YY_BREAK
/* rules to end NAME section processing */
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 377 "lexgrog.l"
{	/* forced exit */
	*p_name = '\0'; /* terminate the string */
	yyterminate ();
}
	YY_BREAK
case 20:
/* rule 20 can match eol */
#line 383 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_PRENAME):
#line 383 "lexgrog.l"
{	/* no NAME at all */
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* need to match whole string so that we beat the following roff catch-all,
    so use yyless to push back the name */

case 21:
/* rule 21 can match eol */
#line 392 "lexgrog.l"
case 22:
/* rule 22 can match eol */
#line 393 "lexgrog.l"
case 23:
/* rule 23 can match eol */
#line 394 "lexgrog.l"
case 24:
/* rule 24 can match eol */
#line 395 "lexgrog.l"
case 25:
/* rule 25 can match eol */
#line 396 "lexgrog.l"
case 26:
/* rule 26 can match eol */
YY_RULE_SETUP
#line 396 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* Skip over initial roff requests in NAME section. The use of yyless here
    is evil. */
case 27:
/* rule 27 can match eol */
YY_RULE_SETUP
#line 404 "lexgrog.l"

	YY_BREAK
case 28:
/* rule 28 can match eol */
YY_RULE_SETUP
#line 406 "lexgrog.l"
yyless (1);
	YY_BREAK
case 29:
/* rule 29 can match eol */
YY_RULE_SETUP
#line 408 "lexgrog.l"
{
	yyless (0);
	BEGIN (MAN_NAME);
}
	YY_BREAK

case 30:
/* rule 30 can match eol */
#line 415 "lexgrog.l"
case 31:
/* rule 31 can match eol */
#line 416 "lexgrog.l"
case 32:
/* rule 32 can match eol */
#line 417 "lexgrog.l"
case 33:
/* rule 33 can match eol */
#line 418 "lexgrog.l"
case 34:
/* rule 34 can match eol */
#line 419 "lexgrog.l"
case 35:
/* rule 35 can match eol */
#line 420 "lexgrog.l"
case 36:
/* rule 36 can match eol */
#line 421 "lexgrog.l"
YY_RULE_SETUP
case YY_STATE_EOF(MAN_NAME):
YY_RULE_SETUP
case YY_STATE_EOF(MAN_DESC):
#line 421 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (MAN_REST);
	}
	YY_BREAK


case 37:
/* rule 37 can match eol */
#line 429 "lexgrog.l"
case 38:
/* rule 38 can match eol */
#line 430 "lexgrog.l"
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 430 "lexgrog.l"
{	/* terminate the string */
		*p_name = '\0';
		BEGIN (CAT_REST);
		yyterminate ();
	}
	YY_BREAK

/* ROFF request removal */

/* some include quoting; dealing with this is unpleasant */
case 40:
/* rule 40 can match eol */
YY_RULE_SETUP
#line 440 "lexgrog.l"
{
		newline_found ();
		waiting_for_quote = 1;
	}
	YY_BREAK
case 41:
/* rule 41 can match eol */
#line 446 "lexgrog.l"
case 42:
/* rule 42 can match eol */
#line 447 "lexgrog.l"
case 43:
/* rule 43 can match eol */
#line 448 "lexgrog.l"
case 44:
/* rule 44 can match eol */
#line 449 "lexgrog.l"
case 45:
/* rule 45 can match eol */
#line 450 "lexgrog.l"
case 46:
/* rule 46 can match eol */
#line 451 "lexgrog.l"
case 47:
/* rule 47 can match eol */
#line 452 "lexgrog.l"
case 48:
/* rule 48 can match eol */
#line 453 "lexgrog.l"
case 49:
/* rule 49 can match eol */
YY_RULE_SETUP
#line 453 "lexgrog.l"
{	/* per line comments */
		newline_found ();
	}
	YY_BREAK

/* No-op requests */

case 50:
/* rule 50 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 460 "lexgrog.l"
newline_found ();
	YY_BREAK
case 51:
/* rule 51 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
YY_LINENO_REWIND_TO(yy_cp - 1);
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 461 "lexgrog.l"
newline_found ();
	YY_BREAK

/* Toggle fill mode */

case 52:
/* rule 52 can match eol */
YY_RULE_SETUP
#line 466 "lexgrog.l"
fill_mode = 0;
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 467 "lexgrog.l"
fill_mode = 1;
	YY_BREAK

case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 470 "lexgrog.l"
/* strip continuations */
	YY_BREAK
/* convert to DASH */

case 55:
/* rule 55 can match eol */
#line 475 "lexgrog.l"
case 56:
/* rule 56 can match eol */
#line 476 "lexgrog.l"
case 57:
/* rule 57 can match eol */
#line 477 "lexgrog.l"
case 58:
/* rule 58 can match eol */
#line 478 "lexgrog.l"
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 478 "lexgrog.l"
{
		add_separator_to_whatis ();
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 483 "lexgrog.l"
add_separator_to_whatis ();
	YY_BREAK
/* escape sequences and special characters */

case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 487 "lexgrog.l"
add_char_to_whatis ('\\');
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 488 "lexgrog.l"
add_char_to_whatis ('\'');
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 489 "lexgrog.l"
add_char_to_whatis ('`');
	YY_BREAK
case 64:
/* rule 64 can match eol */
YY_RULE_SETUP
#line 490 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 65:
/* rule 65 can match eol */
YY_RULE_SETUP
#line 491 "lexgrog.l"
add_char_to_whatis ('-');
	YY_BREAK
case 66:
/* rule 66 can match eol */
YY_RULE_SETUP
#line 492 "lexgrog.l"
add_char_to_whatis ('.');
	YY_BREAK
case 67:
/* rule 67 can match eol */
YY_RULE_SETUP
#line 493 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
case 68:
/* rule 68 can match eol */
YY_RULE_SETUP
#line 494 "lexgrog.l"
add_char_to_whatis ('_');
	YY_BREAK
case 69:
/* rule 69 can match eol */
YY_RULE_SETUP
#line 495 "lexgrog.l"
add_char_to_whatis ('\t');
	YY_BREAK
case 70:
/* rule 70 can match eol */
YY_RULE_SETUP
#line 497 "lexgrog.l"
/* various useless control chars */
	YY_BREAK
case 71:
/* rule 71 can match eol */
YY_RULE_SETUP
#line 498 "lexgrog.l"
/* various inline functions */
	YY_BREAK
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 500 "lexgrog.l"
/* interpolate arg */
	YY_BREAK
/* roff named glyphs */
case 73:
/* rule 73 can match eol */
YY_RULE_SETUP
#line 503 "lexgrog.l"
add_glyph_to_whatis (yytext + 2, 2);
	YY_BREAK
/* perldoc strings */
case 74:
/* rule 74 can match eol */
YY_RULE_SETUP
#line 505 "lexgrog.l"
add_perldoc_to_whatis (yytext + 3, 2);
	YY_BREAK
case 75:
/* rule 75 can match eol */
YY_RULE_SETUP
#line 506 "lexgrog.l"
add_perldoc_to_whatis (yytext + 2, 1);
	YY_BREAK
case 76:
/* rule 76 can match eol */
YY_RULE_SETUP
#line 508 "lexgrog.l"
/* comment */
	YY_BREAK
case 77:
/* rule 77 can match eol */
YY_RULE_SETUP
#line 510 "lexgrog.l"
/* font changes */
	YY_BREAK
case 78:
/* rule 78 can match eol */
YY_RULE_SETUP
#line 511 "lexgrog.l"
/* mark input place in register */
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 513 "lexgrog.l"
/* interpolate number register */
	YY_BREAK
case 80:
/* rule 80 can match eol */
YY_RULE_SETUP
#line 514 "lexgrog.l"
/* overstrike chars */
	YY_BREAK
case 81:
/* rule 81 can match eol */
YY_RULE_SETUP
#line 516 "lexgrog.l"
/* size changes */
	YY_BREAK
case 82:
/* rule 82 can match eol */
YY_RULE_SETUP
#line 517 "lexgrog.l"
/* width of string */
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 519 "lexgrog.l"
/* catch all */
	YY_BREAK
case 84:
/* rule 84 can match eol */
YY_RULE_SETUP
#line 521 "lexgrog.l"
/* function() in hpux */
	YY_BREAK

/* some people rather ambitiously use non-trivial mdoc macros in NAME
    sections; cope with those that have been seen in the wild, and a few
    more */

case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 528 "lexgrog.l"
BEGIN (MAN_DESC_AT);
	YY_BREAK
case 86:
/* rule 86 can match eol */
YY_RULE_SETUP
#line 529 "lexgrog.l"
BEGIN (MAN_DESC_BSX);
	YY_BREAK
case 87:
/* rule 87 can match eol */
YY_RULE_SETUP
#line 530 "lexgrog.l"
BEGIN (MAN_DESC_BX);
	YY_BREAK
case 88:
/* rule 88 can match eol */
YY_RULE_SETUP
#line 531 "lexgrog.l"
BEGIN (MAN_DESC_FX);
	YY_BREAK
case 89:
/* rule 89 can match eol */
YY_RULE_SETUP
#line 532 "lexgrog.l"
BEGIN (MAN_DESC_NX);
	YY_BREAK
case 90:
/* rule 90 can match eol */
YY_RULE_SETUP
#line 533 "lexgrog.l"
BEGIN (MAN_DESC_OX);
	YY_BREAK
case 91:
/* rule 91 can match eol */
YY_RULE_SETUP
#line 534 "lexgrog.l"
add_word_to_whatis ("UNIX");
	YY_BREAK
case 92:
/* rule 92 can match eol */
YY_RULE_SETUP
#line 536 "lexgrog.l"
{
		add_word_to_whatis ("\"");
		BEGIN (MAN_DESC_DQ);
	}
	YY_BREAK


case 93:
YY_RULE_SETUP
#line 543 "lexgrog.l"
mdoc_text ("Version 32V AT&T UNIX");
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 544 "lexgrog.l"
mdoc_text ("Version 1 AT&T UNIX");
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 545 "lexgrog.l"
mdoc_text ("Version 2 AT&T UNIX");
	YY_BREAK
case 96:
YY_RULE_SETUP
#line 546 "lexgrog.l"
mdoc_text ("Version 3 AT&T UNIX");
	YY_BREAK
case 97:
YY_RULE_SETUP
#line 547 "lexgrog.l"
mdoc_text ("Version 4 AT&T UNIX");
	YY_BREAK
case 98:
YY_RULE_SETUP
#line 548 "lexgrog.l"
mdoc_text ("Version 5 AT&T UNIX");
	YY_BREAK
case 99:
YY_RULE_SETUP
#line 549 "lexgrog.l"
mdoc_text ("Version 6 AT&T UNIX");
	YY_BREAK
case 100:
YY_RULE_SETUP
#line 550 "lexgrog.l"
mdoc_text ("Version 7 AT&T UNIX");
	YY_BREAK
case 101:
YY_RULE_SETUP
#line 551 "lexgrog.l"
mdoc_text ("AT&T System V UNIX");
	YY_BREAK
case 102:
YY_RULE_SETUP
#line 552 "lexgrog.l"
mdoc_text ("AT&T System V.1 UNIX");
	YY_BREAK
case 103:
YY_RULE_SETUP
#line 553 "lexgrog.l"
mdoc_text ("AT&T System V.2 UNIX");
	YY_BREAK
case 104:
YY_RULE_SETUP
#line 554 "lexgrog.l"
mdoc_text ("AT&T System V.3 UNIX");
	YY_BREAK
case 105:
YY_RULE_SETUP
#line 555 "lexgrog.l"
mdoc_text ("AT&T System V.4 UNIX");
	YY_BREAK
case 106:
/* rule 106 can match eol */
YY_RULE_SETUP
#line 556 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("AT&T UNIX");
	}
	YY_BREAK


case 107:
YY_RULE_SETUP
#line 563 "lexgrog.l"
{
		add_word_to_whatis ("BSD/OS");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 108:
/* rule 108 can match eol */
YY_RULE_SETUP
#line 568 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD/OS");
	}
	YY_BREAK


case 109:
YY_RULE_SETUP
#line 575 "lexgrog.l"
mdoc_text ("BSD (currently in alpha test)");
	YY_BREAK
case 110:
YY_RULE_SETUP
#line 576 "lexgrog.l"
mdoc_text ("BSD (currently in beta test)");
	YY_BREAK
case 111:
YY_RULE_SETUP
#line 577 "lexgrog.l"
mdoc_text ("BSD (currently under development");
	YY_BREAK
case 112:
YY_RULE_SETUP
#line 578 "lexgrog.l"
{
		add_wordn_to_whatis (yytext, yyleng);
		add_str_to_whatis ("BSD", 3);
		BEGIN (MAN_DESC_BX_RELEASE);
	}
	YY_BREAK
case 113:
/* rule 113 can match eol */
YY_RULE_SETUP
#line 583 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("BSD");
	}
	YY_BREAK


case 114:
YY_RULE_SETUP
#line 590 "lexgrog.l"
{
		add_str_to_whatis ("-Reno", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 115:
YY_RULE_SETUP
#line 594 "lexgrog.l"
{
		add_str_to_whatis ("-Tahoe", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 116:
YY_RULE_SETUP
#line 598 "lexgrog.l"
{
		add_str_to_whatis ("-Lite", 5);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 117:
YY_RULE_SETUP
#line 602 "lexgrog.l"
{
		add_str_to_whatis ("-Lite2", 6);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 118:
/* rule 118 can match eol */
YY_RULE_SETUP
#line 606 "lexgrog.l"
{
		yyless (0);
		BEGIN (MAN_DESC);
	}
	YY_BREAK

case 119:
YY_RULE_SETUP
#line 612 "lexgrog.l"
{
	add_str_to_whatis (yytext, yyleng);
	add_char_to_whatis ('"');
	BEGIN (MAN_DESC);
}
	YY_BREAK

case 120:
YY_RULE_SETUP
#line 619 "lexgrog.l"
{
		add_word_to_whatis ("FreeBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 121:
/* rule 121 can match eol */
YY_RULE_SETUP
#line 624 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("FreeBSD");
	}
	YY_BREAK


case 122:
YY_RULE_SETUP
#line 631 "lexgrog.l"
{
		add_word_to_whatis ("NetBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 123:
/* rule 123 can match eol */
YY_RULE_SETUP
#line 636 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("NetBSD");
	}
	YY_BREAK


case 124:
YY_RULE_SETUP
#line 643 "lexgrog.l"
{
		add_word_to_whatis ("OpenBSD");
		add_wordn_to_whatis (yytext, yyleng);
		BEGIN (MAN_DESC);
	}
	YY_BREAK
case 125:
/* rule 125 can match eol */
YY_RULE_SETUP
#line 648 "lexgrog.l"
{
		yyless (0);
		mdoc_text ("OpenBSD");
	}
	YY_BREAK

/* collapse spaces, escaped spaces, tabs, newlines to a single space */
case 126:
/* rule 126 can match eol */
YY_RULE_SETUP
#line 655 "lexgrog.l"
add_char_to_whatis (' ');
	YY_BREAK
/* a ROFF break request, a paragraph request, or an indentation change
    usually means we have multiple whatis definitions, provide a separator
    for later processing */

case 127:
/* rule 127 can match eol */
#line 662 "lexgrog.l"
case 128:
/* rule 128 can match eol */
#line 663 "lexgrog.l"
case 129:
/* rule 129 can match eol */
#line 664 "lexgrog.l"
case 130:
/* rule 130 can match eol */
#line 665 "lexgrog.l"
case 131:
/* rule 131 can match eol */
#line 666 "lexgrog.l"
case 132:
/* rule 132 can match eol */
#line 667 "lexgrog.l"
case 133:
/* rule 133 can match eol */
#line 668 "lexgrog.l"
case 134:
/* rule 134 can match eol */
YY_RULE_SETUP
#line 668 "lexgrog.l"
{
		add_char_to_whatis ((char) 0x11);
		BEGIN (MAN_NAME);
	}
	YY_BREAK

/* any other roff request we don't recognise terminates definitions */
case 135:
/* rule 135 can match eol */
YY_RULE_SETUP
#line 675 "lexgrog.l"
{
	*p_name = '\0';
	BEGIN (MAN_REST);
}
	YY_BREAK
/* pass words as a chunk. speed optimization */
case 136:
YY_RULE_SETUP
#line 681 "lexgrog.l"
add_str_to_whatis (yytext, yyleng);
	YY_BREAK
/* normalise the comma (,) separators */
case 137:
/* rule 137 can match eol */
#line 685 "lexgrog.l"
case 138:
/* rule 138 can match eol */
YY_RULE_SETUP
#line 685 "lexgrog.l"
add_str_to_whatis (", ", 2);
	YY_BREAK
case 139:
/* rule 139 can match eol */
YY_RULE_SETUP
#line 687 "lexgrog.l"
{
	newline_found ();
	add_char_to_whatis (yytext[yyleng - 1]);
}
	YY_BREAK
case 140:
YY_RULE_SETUP
#line 692 "lexgrog.l"
add_char_to_whatis (*yytext);
	YY_BREAK
/* default EOF rule */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(MAN_DESC_AT):
case YY_STATE_EOF(MAN_DESC_BSX):
case YY_STATE_EOF(MAN_DESC_BX):
case YY_STATE_EOF(MAN_DESC_BX_RELEASE):
case YY_STATE_EOF(MAN_DESC_DQ):
case YY_STATE_EOF(MAN_DESC_FX):
case YY_STATE_EOF(MAN_DESC_NX):
case YY_STATE_EOF(MAN_DESC_OX):
case YY_STATE_EOF(CAT_NAME):
case YY_STATE_EOF(CAT_FILE):
case YY_STATE_EOF(MAN_FILE):
case YY_STATE_EOF(CAT_REST):
case YY_STATE_EOF(FORCE_EXIT):
#line 695 "lexgrog.l"
return 1;
	YY_BREAK
case 141:
YY_RULE_SETUP
#line 697 "lexgrog.l"
ECHO;
	YY_BREAK
#line 4068 "lexgrog.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_last_accepting_cpos);
				yy_current_state = (yy_last_accepting_state);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap(  ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of user's declarations */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	char *source = (yytext_ptr);
	int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr) - 1);

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER_LVALUE;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc( (void *) b->yy_ch_buf,
							 (yy_size_t) (b->yy_buf_size + 2)  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = NULL;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if (((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		int new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc(
			(void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf, (yy_size_t) new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
		/* "- 2" to take care of EOB's */
		YY_CURRENT_BUFFER_LVALUE->yy_buf_size = (int) (new_size - 2);
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	yy_state_type yy_current_state;
	char *yy_cp;
    
	yy_current_state = (yy_start);

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 1494 )
				yy_c = yy_meta[yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	int yy_is_jam;
    	char *yy_cp = (yy_c_buf_p);

	YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 1494 )
			yy_c = yy_meta[yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + yy_c];
	yy_is_jam = (yy_current_state == 1493);

		return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_UNPUT

#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (int) ((yy_c_buf_p) - (yytext_ptr));
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap(  ) )
						return 0;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer( yyin, YY_BUF_SIZE );
	}

	yy_init_buffer( YY_CURRENT_BUFFER, input_file );
	yy_load_buffer_state(  );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state(  );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc( (yy_size_t) (b->yy_buf_size + 2)  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree( (void *) b->yy_ch_buf  );

	yyfree( (void *) b  );
}

/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state(  );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state(  );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state(  );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	yy_size_t num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
      num_to_alloc = 1; /* After all that talk, this was set to 1 anyways... */
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));

		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		yy_size_t grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return NULL;

	b = (YY_BUFFER_STATE) yyalloc( sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = (int) (size - 2);	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = NULL;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (const char * yystr )
{
    
	return yy_scan_bytes( yystr, (int) strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (const char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = (yy_size_t) (_yybytes_len + 2);
	buf = (char *) yyalloc( n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yynoreturn yy_fatal_error (const char* msg )
{
			fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
    
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param _line_number line number
 * 
 */
void yyset_lineno (int  _line_number )
{
    
    yylineno = _line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param _in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  _in_str )
{
        yyin = _in_str ;
}

void yyset_out (FILE *  _out_str )
{
        yyout = _out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  _bdebug )
{
        yy_flex_debug = _bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    (yy_buffer_stack) = NULL;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = NULL;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = NULL;
    yyout = NULL;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer( YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, const char * s2, int n )
{
		
	int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (const char * s )
{
	int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
			return malloc(size);
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
		
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return realloc(ptr, size);
}

void yyfree (void * ptr )
{
			free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 697 "lexgrog.l"


/* print warning and force scanner to terminate */
static void too_big (void)
{
	/* Even though MAX_NAME is a macro expanding to a constant, we
	 * translate it using ngettext anyway because that will make it
	 * easier to change the macro later.
	 */
	error (0, 0,
	       ngettext ("warning: whatis for %s exceeds %d byte, "
			 "truncating.",
			 "warning: whatis for %s exceeds %d bytes, "
			 "truncating.", MAX_NAME),
	       fname, MAX_NAME);

	BEGIN (FORCE_EXIT);
}

/* append a string to newname if enough room */
static void add_str_to_whatis (const char *string, size_t length)
{
	if (p_name - newname + length >= MAX_NAME)
		too_big ();
	else {
		(void) strncpy (p_name, string, length);
		p_name += length;
	}
} 

/* append a char to newname if enough room */
static void add_char_to_whatis (unsigned char c)
{
	if (p_name - newname + 1 >= MAX_NAME)
		too_big ();
	else if (waiting_for_quote && c == '"')
		waiting_for_quote = 0;
	else
		*p_name++ = c;
}

/* append the " - " separator to newname, trimming the first space if one's
 * already there
 */
static void add_separator_to_whatis (void)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	add_str_to_whatis ("- ", 2);
}

/* append a word to newname if enough room, ensuring only necessary
   surrounding space */
static void add_wordn_to_whatis (const char *string, size_t length)
{
	if (p_name != newname && *(p_name - 1) != ' ')
		add_char_to_whatis (' ');
	while (length && string[length - 1] == ' ')
		--length;
	if (length)
		add_str_to_whatis (string, length);
}

static void add_word_to_whatis (const char *string)
{
	add_wordn_to_whatis (string, strlen (string));
}

struct compare_macro_key {
	const char *string;
	size_t length;
};

static int compare_macro (const void *left, const void *right)
{
	const struct compare_macro_key *key = left;
	const struct macro *value = right;
	int cmp;

	cmp = strncmp (key->string, value->name, key->length);
	if (cmp)
		return cmp;
	/* equal up to key->length, so value->name must be at least size
	 * key->length + 1
	 */
	else if (value->name[key->length])
		return -1;
	else
		return 0;
}

static void add_macro_to_whatis (const struct macro *macros, size_t n_macros,
				 const char *string, size_t length)
{
	struct compare_macro_key key;
	const struct macro *macro;

	key.string = string;
	key.length = length;
	macro = bsearch (&key, macros, n_macros, sizeof (struct macro),
			 compare_macro);
	if (macro)
		add_str_to_whatis (macro->value, strlen (macro->value));
}

static void add_glyph_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (glyphs, ARRAY_SIZE (glyphs), string, length);
}

static void add_perldoc_to_whatis (const char *string, size_t length)
{
	add_macro_to_whatis (perldocs, ARRAY_SIZE (perldocs), string, length);
}

static void mdoc_text (const char *string)
{
	add_word_to_whatis (string);
	BEGIN (MAN_DESC);
}

static void newline_found (void)
{
	/* If we are mid p_name and the last added char was not a space,
	 * best add one.
	 */
	if (p_name != newname && *(p_name - 1) != ' ') {
		if (fill_mode)
			add_char_to_whatis (' ');
		else {
			add_char_to_whatis ((char) 0x11);
			BEGIN (MAN_NAME);
		}
	}
	waiting_for_quote = 0;
}

int find_name (const char *file, const char *filename, lexgrog *p_lg,
	       const char *encoding)
{
	int ret;
	pipeline *p;
	char *page_encoding = NULL;

	if (strcmp (file, "-") == 0) {
		p = decompress_fdopen (dup (STDIN_FILENO));
	} else {
		struct stat st;
		char *lang;

		if (stat (file, &st)) {
			error (0, errno, "%s", file);
			return 0;
		}

		if (S_ISDIR (st.st_mode)) {
			error (0, EISDIR, "%s", file);
			return 0;
		}

		drop_effective_privs ();
		p = decompress_open (file);
		if (!p) {
			error (0, errno, _("can't open %s"), file);
			regain_effective_privs ();
			return 0;
		}
		regain_effective_privs ();

		if (!encoding) {
			lang = lang_dir (file);
			page_encoding = get_page_encoding (lang);
			free (lang);
		}
	}
	if (!page_encoding && encoding)
		page_encoding = xstrdup (encoding);
	if (page_encoding)
		add_manconv (p, page_encoding, "UTF-8");
	free (page_encoding);
	if (p_lg->type && *COL) {
		pipecmd *col_cmd;
		col_cmd = pipecmd_new_args (COL, "-b", "-p", "-x", (void *) 0);
		pipecmd_pre_exec (col_cmd, sandbox_load, sandbox_free,
				  sandbox);
		pipeline_command (p, col_cmd);
	}
	pipeline_start (p);

	ret = find_name_decompressed (p, filename, p_lg);
	pipeline_free (p);
	return ret;
}

int find_name_decompressed (pipeline *p, const char *filename, lexgrog *p_lg)
{
	int ret;

	decomp = p;

	fname = filename;
	*(p_name = newname) = '\0';
	memset (filters, '_', sizeof (filters));

	fill_mode = 1;
	waiting_for_quote = 0;

	if (p_lg->type)
		BEGIN (CAT_FILE);
	else
		BEGIN (MAN_FILE);

	drop_effective_privs ();

	yyrestart (NULL);
	ret = yylex ();

	regain_effective_privs ();

	pipeline_wait (decomp);

	if (ret)
		return 0;
	else {
		char f_tmp[MAX_FILTERS];
		int j, k;

		/* wipe out any leading or trailing spaces */
		if (*newname) {
			for (p_name = strchr (newname, '\0');
			     *(p_name - 1) == ' ';
			     p_name--);
			if (*p_name == ' ')
				*p_name = '\0';
		}
		for (p_name = newname; *p_name == ' '; p_name++);
		p_lg->whatis = xstrdup (p_name);
		memset (f_tmp, '\0', MAX_FILTERS);
		f_tmp[0] = '-';
		for (j = k = 0; j < MAX_FILTERS; j++)
			if (filters[j] != '_')
				f_tmp[k++] = filters[j];
		p_lg->filters = xstrdup (f_tmp);
		return p_name[0];
	}
}

